#define size_t int

#ifndef __cplusplus


#warning   "This is only for the interface"


/**
 * @brief Struct to store all the kernel names of a given region.
  */
  typedef struct {
     char kernel_name[MAX_KERNEL_NAME];
     } tkernel_list;

/**
* @brief Struct to store all the information regarding with the kernel parameters.
*/
typedef struct _tparams{
   void * _base_ptr;
   int type;
   char* reduction;
   char* reductionType;
   char* identity;
   unsigned int canChange;
   struct _tparams * next;
} tparams;


#endif


#ifdef __cplusplus
extern "C" {
#endif

	/* Kind of parameters */
	//#define VAR_SCALAR 0
	//#define VAR_ARRAY 1
	/* #define VAR_IN 0
	#define VAR_OUT 1
	#define VAR_INOUT 2*/

    /* Kind of variables */
    #define VAR_SCALAR 0
    #define VAR_ARRAY 1
    /* Var. directionality */
    #define VAR_IN 0x0           // Is used inside context but not required again outside
    #define VAR_OUT 0x1          // Is used outside after context but not init. before
    #define VAR_INOUT 0x2        // Is required both pre-context and after-context
    #define VAR_PRIVATE 0x3      // It exists only within the context
    #define VAR_RW 0x00
    #define VAR_RONLY 0x10
    #define VAR_WONLY 0x20
    #define FORCE_COPY_IN 0
    #define COPY_FIRST_ONLY 1


	void createVar(void * var, int rid, size_t size, int varDirection);

	int launch_kernel(int regionID, char * kernelName, tparams * params, int size);
	int launch_kernel2D(int regionID, char * kernelName, tparams * params, int size_x, int size_y);

    int beginRegion(char * name, tkernel_list * kernel_name_list);


    int concyle(int regionId, void * varPtr);
#ifdef __cplusplus
}
#endif 
