# -*- coding: utf-8 -*-
# --------------------------------------------------------------------------------
# Copyright (c) 2012, Francisco de Sande González. 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
# 
# * Redistributions of source code must retain the above copyright notice, this 
#   list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright notice, 
#   this list of conditions and the following disclaimer in the documentation 
#   and/or other materials provided with the distribution.
# * Neither the name of Francisco de Sande nor the names of its contributors may 
#   be used to endorse or promote products derived from this software without 
#   specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE 
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
# GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE
# --------------------------------------------------------------------------------


from Frontend.CUDA.plyparser import PLYParser, Coord, ParseError
from Frontend.CUDA.cuda_lexer import CUDALexer
from Frontend.CUDA import cuda_ast
from Frontend.C99 import c99_ast as c_ast

from Frontend.C99.c99_parser import C99Parser

class CUDAParser(PLYParser):

#	def __init__( 
#		self, 
#		lex_optimize=False,
#        lextab='Frontend.C99.lextab',
#        yacc_optimize=False,
#        yacctab='Frontend.C99.yacctab',
#        yacc_debug=False, 
#        lexer_class = CUDALexer):
#    	#super(C99Parser, self).__init__(self, lex_optimize, lextab, yacc_optimize,yacctab, yacc_debug, lexer_class)
#	    #super(C99Parser, self).__init__(self) 
#		C99Parser.__init__(self, lex_optimize, lextab, yacc_optimize,yacctab, yacc_debug, lexer_class)
#
	def p_external_declaration_5(self, p):
		""" external_declaration    : cuda_kernel
		"""
		p[0] = p[1]


	def p_cuda_kernel(self, p):
		""" cuda_kernel : GLOBAL function_definition """
		p[0] = p[2]
		p[0] = c_ast.CUDAKernel(
                    name=p[2].decl.name,
                    type='global',
                    function = p[2],
                    coord=p[2].coord)


	def p_postfix_expression_7(self, p):
		""" postfix_expression  : postfix_expression LKLAUNCH primary_expression COMMA primary_expression RKLAUNCH LPAREN argument_expression_list RPAREN
        	                    | postfix_expression LKLAUNCH primary_expression COMMA primary_expression RKLAUNCH LPAREN  RPAREN
		"""
		p[0] = c_ast.CUDAKernelCall(p[1], p[3], p[5], p[8] if len(p) > 9 else None, p[1].coord)

 
	# Ruyk : Directives inside statements
	#def p_statement_1(self, p):
	#    """ statement : pp_directive
	#    """
	#    p[0] = p[1][0]


