'''
Created on Jul 8, 2012

@author: jlucasgl (jlucas.gl@gmail.com)

'''

from MiddleEnd.Loop.Analysis import ParametrizeLoopTool
from Backends.Common.Mutators.AbstractMutator import AbstractMutator

from Tools.Tree import ReplaceTool, getContainerAttribute
from Frontend.Shortcuts import getCurrentLanguageAst
from Backends.Common.Visitors.GenericVisitors import GenericFilterVisitor
c_ast = getCurrentLanguageAst()

from Frontend.Acc import acc_ast

from Tools.Tree import NodeNotFound


class AccConstructFilter(GenericFilterVisitor):
    """ Returns the first node with the given attribute
    """
    def __init__(self):
        def condition(node):
            if type(node) == acc_ast.AccKernels or \
		    type(node) == acc_ast.AccParallel:
		return True
            return False
        super(AccConstructFilter, self).__init__(condition_func = condition)


class AccGangFilter(GenericFilterVisitor):
    """ Returns the first node with the given attribute
    """
    def __init__(self):
        def condition(node):
            if type(node) == acc_ast.AccParallelOption:
		if node.name == 'gang':
		    return True
            return False
        super(AccGangFilter, self).__init__(condition_func = condition)

class AccWorkerFilter(GenericFilterVisitor):
    """ Returns the first node with the given attribute
    """
    def __init__(self):
        def condition(node):
            if type(node) == acc_ast.AccParallelOption and \
		    node.name == 'worker':
		return True
            return False
        super(AccWorkerFilter, self).__init__(condition_func = condition)


class AccLoopGangFilter(GenericFilterVisitor):
    """ Returns the first node with the given attribute
    """
    def __init__(self):
        def condition(node):
            if type(node) == acc_ast.AccLoop:
		#print "buscado en " + str(node.name)
		for subnode in node.clauses:
		    try:
			AccGangFilter().apply(subnode)
			return True
		    except (NodeNotFound):
			pass
            return False
        super(AccLoopGangFilter, self).__init__(condition_func = condition)

class AccLoopWorkerFilter(GenericFilterVisitor):
    """ Returns the first node with the given attribute
    """
    def __init__(self):
        def condition(node):
            if type(node) == acc_ast.AccLoop:
		#print "buscado en " + str(node.name)
		for subnode in node.clauses:
		    try:
			AccWorkerFilter().apply(subnode)
			return True
		    except (NodeNotFound):
			pass
            return False
        super(AccLoopWorkerFilter, self).__init__(condition_func = condition)