#include "llcomp_llc.h" 

    

        typedef  double real8;
        typedef  double vnd_t [3];
     
     void loopParallelFor1_support(  int *_np,  real8 *_pot,  int *_k,  vnd_t *rij,  real8 *box,  vnd_t *f,  real8 *_kin,  real8 *_d,  int *_i,  int *_nd,  vnd_t *pos,  vnd_t *vel,  int *_j) ;
     void loopParallelFor1_support(  int *_np,  real8 *_pot,  int *_k,  vnd_t *rij,  real8 *box,  vnd_t *f,  real8 *_kin,  real8 *_d,  int *_i,  int *_nd,  vnd_t *pos,  vnd_t *vel,  int *_j)  {
                 int np = *_np;
                 real8 pot = *_pot;
                 int k = *_k;
                 real8 kin = *_kin;
                 real8 d = *_d;
                 int i = *_i;
                 int nd = *_nd;
                 int j = *_j;
        /* Begin template: forall_init_unit.tmpl */

/* $0 => Variable del bucle
 * loop_initial => Valor inicial de la variable del bucle B
 * loop_finalice => Valor final de la variable del bucle C
 */

{
    int llc_meanT, llc_rnT;
    register int llc_i;

    llc_nT = ((np - 1) - (0) + 1);
    /* Medium number of tasks */
    llc_meanT = llc_nT / LLC_NUMPROCESSORS;
    /* Number of unassigned tasks */
    llc_rnT = llc_nT % LLC_NUMPROCESSORS;

    LLC_CHECK_MALLOC (llc_F, (LLC_NUMPROCESSORS + 1), int);

    llc_F[0] = 0;
    for (llc_i = 1; llc_i < (LLC_NUMPROCESSORS + 1); llc_i++) {
        llc_F[llc_i] = llc_F[llc_i-1] + llc_meanT + (((llc_i - 1) < llc_rnT) ? 1 : 0);
    }
}

/* End template: forall_init_unit.tmpl */
/* Begin template: forall_exec_unit.tmpl */

/* loop_var => Variable del bucle
 * loop_initial => Valor inicial de la variable del bucle
 * loop_stmt => Bloque del bucle
 */

{
    int llc_nP;
    int llc_grp_save;
    register int llc_i;

    llc_nP = LLC_NUMPROCESSORS;
    llc_grp_save = LLC_NAME;
    LLC_NUMPROCESSORS = 1;
    LLC_NAME = 0;
    
    i = (0) + llc_F[llc_grp_save];
    for (llc_i = 0; llc_i < LLC_PROCSGRP(llc_grp_save); llc_i++, i++) {
        
{

  for (j= 0; j < nd; (j++ )) f[i][j]= 0.0 ;
  for (j= 0; j < np; (j++ ))  
{

    if     (i != j    )     
{

d= dist(nd,box,pos[i],pos[j],rij) ;
pot= pot + (0.5 * v(d) );
      for (k= 0; k < nd; (k++ ))      
{

f[i][k]= f[i][k] - ((*rij[k] * dv(d) ) / d);
      }

 ;
    }

;
  }

 ;
kin= kin + dotr8(nd,vel[i],vel[j]) ;
}

;
    }

    LLC_NAME = llc_grp_save;
    LLC_NUMPROCESSORS = llc_nP;
}

/* End template: forall_exec_unit.tmpl */
/* Begin template: forall_comm_unit.tmpl */

/* loop_var => Variable del bucle
 * loop_initial => Valor inicial de la variable del bucle
 * loop_finalice => Valor final de la variable del bucle
 * forall_comm_res_init => template dinamico que se utiliza para reservar memoria para las comunicaciones
 * forall_comm_res_pack => template dinamico que se utiliza para realizar las comunicaciones
 */

{
    register int llc_i, llc_j;
    long llc_buf_size = 0, llc_size_tmp = 0;
    char *llc_buf = NULL, *llc_buf_ptr = NULL;

    for (llc_i = 0; llc_i < LLC_NUMPROCESSORS; llc_i++) {
        llc_size_tmp = 0;
        for (llc_j = 0, i = (0) + llc_F[llc_i]; llc_j < LLC_PROCSGRP(llc_i); llc_j++, i++) {
            llc_size_tmp += (1) * sizeof ((&f[i])[0]);

        }
        llc_buf_size = LLC_MAX(llc_buf_size, llc_size_tmp);
    }
    
    if (llc_buf_size > 0) {
        
        LLC_CHECK_MALLOC (llc_buf, llc_buf_size, char);
        
        for (llc_i = 0; llc_i < LLC_NUMPROCESSORS; llc_i++) {
            if (llc_i == LLC_NAME) {
                    
                /* Simple element. Don't pack */
                if (LLC_PROCSGRP(llc_i) == 1) {
                    i = (0) + llc_F[llc_i];
                    MPI_Bcast(&f[i], ((1) * sizeof((&f[i])[0])), MPI_BYTE, llc_i, *llc_CurrentGroup); 
                }
                /* Multiple elements. Pack */
                else {
                    llc_buf_ptr = llc_buf;
                    
                    for (llc_j = 0, i = (0) + llc_F[llc_i]; llc_j < LLC_PROCSGRP(llc_i); llc_j++, i++) {
                        /* Packing &f[i]... */
memcpy (llc_buf_ptr, &f[i], (1) * sizeof ((&f[i])[0]));
llc_buf_ptr += (1) * sizeof ((&f[i])[0]);

                    }
                    
                    MPI_Bcast(llc_buf, (llc_buf_ptr - llc_buf), MPI_BYTE, llc_i, *llc_CurrentGroup);
                }
            }
            else {
                /* Simple element. Don't unpack */
                if (LLC_PROCSGRP(llc_i) == 1) {
                    i = (0) + llc_F[llc_i];
                    MPI_Bcast(&f[i], ((1) * sizeof((&f[i])[0])), MPI_BYTE, llc_i, *llc_CurrentGroup);
                }
                /* Multiple elements. Unpack */
                else {
                    llc_size_tmp = 0;
                    
                    for (llc_j = 0, i = (0) + llc_F[llc_i]; llc_j < LLC_PROCSGRP(llc_i); llc_j++, i++) {
                        llc_size_tmp += (1) * sizeof ((&f[i])[0]);

                    }
                    
                    MPI_Bcast(llc_buf, llc_size_tmp, MPI_BYTE, llc_i, *llc_CurrentGroup);
                    
                    llc_buf_ptr = llc_buf;
                    
                    for (llc_j = 0, i = (0) + llc_F[llc_i]; llc_j < LLC_PROCSGRP(llc_i); llc_j++, i++) {
                            /* Unpacking &f[i]... */
memcpy (&f[i], llc_buf_ptr, (1) * sizeof ((&f[i])[0]));
llc_buf_ptr += (1) * sizeof ((&f[i])[0]);


                    }
                }
            }
        }
        free (llc_buf);
    }
}

/* End template: forall_comm_unit.tmpl */
/* Begin template: forall_comm_red.tmpl */

{
    register int llc_i;
    int llc_buf_size = 0;
    char *llc_buf = NULL, *llc_buf_ptr = NULL, *llc_buf_tmp = NULL;
    MPI_Status llc_status;

    llc_buf_size += sizeof (real8 );
llc_buf_size += sizeof (real8 );
 

    if (llc_buf_size > 0) {
        
        LLC_CHECK_MALLOC (llc_buf, llc_buf_size, char);

        if (LLC_NAME == 0) {
            for (llc_i = 1; llc_i < LLC_NUMPROCESSORS; llc_i++) {
                MPI_Recv (llc_buf, llc_buf_size, MPI_BYTE, llc_i, LLC_TAG_REDUCE_DATA, *llc_CurrentGroup, &llc_status);
                llc_buf_ptr = llc_buf;

pot += (*(real8  *) llc_buf_ptr);
llc_buf_ptr +=  sizeof(real8 );
kin += (*(real8  *) llc_buf_ptr);
llc_buf_ptr +=  sizeof(real8 );
 
            }

            llc_buf_ptr = llc_buf;

memcpy (llc_buf_ptr, &pot, sizeof(real8 ));
llc_buf_ptr += sizeof(real8 );
memcpy (llc_buf_ptr, &kin, sizeof(real8 ));
llc_buf_ptr += sizeof(real8 );
 
            
            MPI_Bcast (llc_buf, llc_buf_size, MPI_BYTE, 0, *llc_CurrentGroup);
        }
        else {
            llc_buf_ptr = llc_buf;

memcpy (llc_buf_ptr, &pot, sizeof(real8 ));
llc_buf_ptr += sizeof(real8 );
memcpy (llc_buf_ptr, &kin, sizeof(real8 ));
llc_buf_ptr += sizeof(real8 );
 
            
            MPI_Send (llc_buf, llc_buf_size, MPI_BYTE, 0, LLC_TAG_REDUCE_DATA, *llc_CurrentGroup);
            MPI_Bcast (llc_buf, llc_buf_size, MPI_BYTE, 0, *llc_CurrentGroup);
            
            llc_buf_ptr = llc_buf;

memcpy (&pot, llc_buf_ptr, sizeof(real8 ));
llc_buf_ptr += sizeof(real8 );
memcpy (&kin, llc_buf_ptr, sizeof(real8 ));
llc_buf_ptr += sizeof(real8 );

        }	

        free (llc_buf);
        free (llc_buf_tmp);
    }
}

/* End template: forall_comm_red.tmpl */
/* Begin template: forall_exit.tmpl */

    free(llc_F);
    llc_F = NULL;

/* End template: forall_exit.tmpl */

                *_np = np;
                *_pot = pot;
                *_k = k;
                *_kin = kin;
                *_d = d;
                *_i = i;
                *_nd = nd;
                *_j = j;

    }

    
