
#include "llc.h"


# line 10 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 
#define SEQ_TIME 0.0
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#ifndef RAND_MAX
#define RAND_MAX 0x7fff
#endif
#ifndef M_PI_2
#define M_PI_2   1.57079632679489661923
#endif
#define ndim 3
#define nparts 8192
#define nsteps 10
#define NDIM ndim
#define NPARTS nparts
#define NSTEPS nsteps
int NAME, NUMPROCESSORS;
int sendcounts [64], sdispls [64], recvcounts [64], rdispls [64];
typedef double real8;
typedef double vnd_t [ndim];
double t () {
  struct timeval tv;
  
  gettimeofday (&tv, ((void *) 0));
  return (double) tv.tv_sec + (double) tv.tv_usec / 1000000.0;
}



# line 52 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 
double llc_time;
real8 v (real8 x) {
  
  if (x < M_PI_2)
    return pow (sin (x), 2.0);
  
  else
    return 1.0;
  
}



# line 65 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 
real8 dv (real8 x) {
  
  if (x < M_PI_2)
    return 2.0 * sin (x) * cos (x);
  
  else
    return 0.0;
  
}



# line 76 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 
void initialize (int np, int nd, vnd_t box, vnd_t *pos, vnd_t *vel, vnd_t *acc) {
  int i, j;
  real8 x;
  
  srand (4711L);
  for (i = 0; i < np; i++) {
    for (j = 0; j < nd; j++) {
      x = rand () % 10000 / (real8) 10000.0;
      pos[i][j] = box[j] * x;
      vel[i][j] = 0.0;
      acc[i][j] = 0.0;
    }
  }
}



# line 93 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 
real8 dist (int nd, vnd_t box, vnd_t r1, vnd_t r2, vnd_t dr) {
  int i;
  real8 d;
  
  d = 0.0;
  for (i = 0; i < nd; i++) {
    dr[i] = r1[i] - r2[i];
    d += dr[i] * dr[i];
  }
  return sqrt (d);
}



# line 107 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 
real8 dotr8 (int n, vnd_t x, vnd_t y) {
  int i;
  real8 t = 0.0;
  
  for (i = 0; i < n; i++) {
    t += x[i] * y[i];
  }
  return t;
}



# line 122 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 
void update (int np, int nd, vnd_t *pos, vnd_t *vel, vnd_t *f, vnd_t *a, real8 mass, real8 dt) {
  int i, j;
  real8 rmass;
  
  rmass = 1.0 / mass;
  
# line 1 "LLC code (/src/parser/llc_src/forall/forall_init_unit.src)" 
		/*  START CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_init_unit.src'  */

	{	
	  /* i => Variable del bucle
	   * 0 => Valor inicial de la variable del bucle
	   * ((np) - 1) => Valor final de la variable del bucle
	   * 1 => Peso(s)
		 * LLC_NO_WEIGHTS => Flags de asignacin equitativa por pesos (LLC_WEIGHTS/LLC_NO_WEIGHTS)
		 */
	  if(LLC_NUMPROCESSORS == 1) {
	    llc_case = LLC_SEQUENTIAL;
	  }
	  else {
			if ((llc_nT = ((((np) - 1)) - (0) + 1)) >= LLC_NUMPROCESSORS) {
	  	 	register int llc_i, llc_j, llc_k;
				int llc_rnT, llc_w, llc_mW;

	  		llc_case = LLC_BLOCK;

				if ((LLC_NO_WEIGHTS) == LLC_WEIGHTS) {

							/* begin: LLC_WEIGHTS */
		    /* Obtain medium weight (only weight > 0) */
	  	    for(llc_mW = 0, i = 0; i <= ((np) - 1); i++) {
				  	if ((1) > 0) {
							llc_mW += (1);
						}
					}
					llc_mW /= LLC_NUMPROCESSORS;

		   		LLC_CHECK_MALLOC (llc_F, (LLC_NUMPROCESSORS + 1), int);
					llc_F[0] = 0;
					llc_rnT = llc_nT - LLC_NUMPROCESSORS;
		
					/* Weighted task assignement */
					i = 0;
	  	 		for(llc_i = 0; llc_i < LLC_NUMPROCESSORS; llc_i++) {
						llc_F[llc_i + 1] = llc_F[llc_i] + 1;
						llc_w = 1;
						i++;
						while ((llc_rnT > 0) && (llc_w < (llc_mW + LLC_WEIGHT_TOL))) {
							llc_F[llc_i + 1]++;
							llc_w += 1;
							i++;
							llc_rnT--;
						}
					}

					llc_i = 0;			/* Unassigned tasks: Cyclic assignment */
					while (llc_rnT > 0) {
						llc_F[(llc_i % LLC_NUMPROCESSORS) + 1]++;
						llc_rnT--;
						llc_i++;
					}
		 		}  			/* end: LLC_WEIHGTS */
				else {
								/* begin: LLC_NO_WEIGHTS */
					register int llc_i;
					/* Medium number of tasks */
					int llc_meanT = llc_nT / LLC_NUMPROCESSORS;
					/* Number of unassigned tasks */
					int llc_rnT = llc_nT % LLC_NUMPROCESSORS;
		   		
					LLC_CHECK_MALLOC (llc_F, (LLC_NUMPROCESSORS + 1), int);
					
					llc_F[0] = 0;
					for (llc_i = 1; llc_i < (LLC_NUMPROCESSORS + 1); llc_i++) { 
						llc_F[llc_i] = llc_F[llc_i-1] + llc_meanT + (((llc_i - 1) < llc_rnT) ? 1 : 0);
					}
				} 			/* end: LLC_NO_WEIGHTS */
				
			} /* LLC_BLOCK */
	  	else if(llc_nT > 0) {
				llc_case = LLC_GROUPS;
				
				if ((LLC_NO_WEIGHTS) == LLC_WEIGHTS) {
	  	 		register int llc_i, llc_j, llc_k;
	 	 			int *llc_ptr;
					int *llc_W, llc_nW;
	  			int *llc_P, llc_nP;
	  			int *llc_G;
	 
							/* begin: LLC_WEIGHTS */


	    	/* ------------------------------------------------------------
	      	 Weights processing: Threads with non-possitive weight are
		       discarded
	  	     ------------------------------------------------------------ */

					LLC_CHECK_MALLOC (llc_ptr, 3 * llc_nT, int);
					llc_W = llc_ptr;
					llc_P = llc_ptr + llc_nT;
					llc_G = llc_ptr + (2 * llc_nT);

			  	llc_k = llc_nP = LLC_NUMPROCESSORS - llc_nT + 1;
	    		for(llc_nW = 0, llc_i = 0, i = (0); i <= (((np) - 1)); i++, llc_i++) {
		      	if((llc_W[llc_i] = (1)) > 0) {
	  	      	llc_nW += llc_W[llc_i];
	    	    	if(llc_W[llc_i] < llc_k) llc_k = llc_W[llc_i];
	      		}
		      	else
	  	      	llc_W[llc_i] = 0;
	    		}

		    	/* Weights normalization */
		
	  	  	if(llc_k < llc_nP)
	    	  	for(llc_i = 0; llc_i < llc_nT; llc_i++) {
	      		 	llc_W[llc_i] *= llc_nP;
		        	llc_W[llc_i] /= llc_k;
	  	    	}

		    	/* ------------------------------------------------------------
	  	     	Processors assigment policy: BLOCK
	    	   	At least one processor by thread
	      	 	------------------------------------------------------------ */

		   		for(llc_i = 0; llc_i < llc_nT; llc_i++) {
	  	    	llc_P[llc_i] = 1;

		      	llc_j = llc_i;
	  	    	while((llc_j > 0) && (llc_W[llc_i] > llc_W[llc_G[llc_j - 1]])) {
	    	    	llc_G[llc_j] = llc_G[llc_j - 1];
	      	  	llc_j--;
		      	}
	  	    	llc_G[llc_j] = llc_i;
	    		}

		    	llc_nP = llc_nT;
	  	  	while(llc_nP++ < LLC_NUMPROCESSORS) {
	    	  	llc_W[llc_G[0]] = (llc_W[llc_G[0]] * llc_P[llc_G[0]]) /
	      	                (llc_P[llc_G[0]] + 1);
	      		llc_P[llc_G[0]]++;
		      	llc_k = llc_G[0];
	  	    	llc_j = 1;
	    	  	while((llc_j < llc_nT) && (llc_W[llc_G[llc_j]] > llc_W[llc_G[llc_j-1]])) {
	      	  	llc_G[llc_j-1] = llc_G[llc_j];
		        	llc_j++;
	  	    	}
	    	  	llc_G[llc_j-1] = llc_k;
		    	}

	  	  	/* ------------------------------------------------------------
	    	  	 Groups creation
		    	   ------------------------------------------------------------ */

					LLC_CHECK_MALLOC (llc_F, (llc_nT + 1), int);
	  	  	
					llc_F[0] = 0;
	    		for(llc_i = 1; llc_i <= llc_nT; llc_i++)
		      	llc_F[llc_i] = llc_F[llc_i-1] + llc_P[llc_i-1];
	  	                                                    		

	  	  	/* ------------------------------------------------------------
							Auxiliar variables deallocation
		    	   ------------------------------------------------------------ */

		    	free(llc_ptr);
		 		}  			/* end: LLC_WEIHGTS */
				else {
								/* begin: LLC_NO_WEIGHTS */

					register int llc_i;
					/* Medium number of processors */
					int llc_meanP = LLC_NUMPROCESSORS / llc_nT;
					/* Number of unassigned processors */
					int llc_rnP = LLC_NUMPROCESSORS % llc_nT;
		   		
					LLC_CHECK_MALLOC (llc_F, (llc_nT + 1), int);
					
					llc_F[0] = 0;
					for (llc_i = 1; llc_i < (llc_nT + 1); llc_i++) { 	
						llc_F[llc_i] = llc_F[llc_i-1] + llc_meanP + (((llc_i - 1) < llc_rnP) ? 1 : 0);
		
					}
		
				} 			/* end: LLC_NO_WEIGHTS */

	  	  /* Get the group name */
	  	  llc_grp = 0;
	 	  	while(LLC_NAME >= llc_F[llc_grp+1]) llc_grp++;
				
			} /* LLC_GROUPS */
	  	else llc_case = LLC_ERROR_CASE;
		}
	}




		/*  END CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_init_unit.src'  */


# line 139 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 

# line 1 "LLC code (/src/parser/llc_src/forall/forall_exec_unit.src)" 
		/*  START CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_exec_unit.src'  */

	{
		/* i => Variable del bucle
		 * 0 => Valor inicial de la variable del bucle
		 * ((np) - 1) => Valor final de la variable del bucle
		 * dolar3 => Bloque del bucle
		 */
		
	  int llc_case_save = llc_case;

	  switch(llc_case) {
	    case LLC_SEQUENTIAL:
	      for(i = (0); i <= (((np) - 1)); (i)++)
	         {
    for (j = 0; j < nd; j++) {
      pos[i][j] = pos[i][j] + vel[i][j] * dt + 0.5 * dt * dt * a[i][j];
      vel[i][j] = vel[i][j] + 0.5 * dt * (f[i][j] * rmass + a[i][j]);
      a[i][j] = f[i][j] * rmass;
    }
  };
	    break;
	    case LLC_BLOCK:
				{
				  int llc_nP;
					register int llc_i;
				  int llc_nT_save;
				  int llc_grp_save;
					llc_var_reg_data llc_nc_result_list_save;

	 	     	llc_nP = LLC_NUMPROCESSORS;
					llc_grp_save = LLC_NAME;
		      LLC_NUMPROCESSORS = 1;
	  	    LLC_NAME = 0;
	/*				llc_nc_result_list_save_copy (llc_nc_result_list_save); */

					i = (0) + llc_F[llc_grp_save];
					for(llc_i = 0; llc_i < LLC_PROCSGRP(llc_grp_save); llc_i++, i++) {
						 {
    for (j = 0; j < nd; j++) {
      pos[i][j] = pos[i][j] + vel[i][j] * dt + 0.5 * dt * dt * a[i][j];
      vel[i][j] = vel[i][j] + 0.5 * dt * (f[i][j] * rmass + a[i][j]);
      a[i][j] = f[i][j] * rmass;
    }
  };
					}
					
	/*	      if (llc_nc_result_list.num_var > 0) {
	        	llc_nc_result_destroy_var_list();
					}
	        llc_nc_result_list = llc_nc_result_list_save; */
	  	   	LLC_NAME = llc_grp_save;
	    	 	LLC_NUMPROCESSORS = llc_nP;
				}
		    break;

	    case LLC_GROUPS:
				{	
					MPI_Comm *llc_AuxGroup, llc_SubGroup;
				  int llc_nT_save;
				  int llc_grp_save;
				  int *llc_F_save;
					llc_var_reg_data llc_nc_result_list_save;


		      LLC_NAME -= llc_F[llc_grp];
	  	    LLC_NUMPROCESSORS = llc_F[llc_grp+1] - llc_F[llc_grp];
		      MPI_Comm_split(*llc_CurrentGroup, llc_grp, LLC_NAME, &llc_SubGroup);
	  	    llc_AuxGroup = llc_CurrentGroup;
	    	  llc_CurrentGroup = &llc_SubGroup;
	      	llc_nT_save = llc_nT;
		      llc_grp_save = llc_grp;
	  	    llc_F_save = llc_F;
	/*				llc_nc_result_list_save_copy (llc_nc_result_list_save); */
	        

	    	  i = (0) + llc_grp;
					 {
    for (j = 0; j < nd; j++) {
      pos[i][j] = pos[i][j] + vel[i][j] * dt + 0.5 * dt * dt * a[i][j];
      vel[i][j] = vel[i][j] + 0.5 * dt * (f[i][j] * rmass + a[i][j]);
      a[i][j] = f[i][j] * rmass;
    }
  };

	/*        if (llc_nc_result_list.num_var > 0) {
	        	llc_nc_result_destroy_var_list();
					}
	        llc_nc_result_list = llc_nc_result_list_save; */
		      llc_F = llc_F_save;
	  	    llc_grp = llc_grp_save;
	    	  llc_nT = llc_nT_save;
		      LLC_NUMPROCESSORS = llc_F[llc_nT];
	  	    LLC_NAME += llc_F[llc_grp];
	    	  llc_CurrentGroup = llc_AuxGroup;
	      	MPI_Comm_free(&llc_SubGroup);
				}
		    break;
	  	}
	  llc_case = llc_case_save;
	}



		/*  END CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_exec_unit.src'  */


# line 139 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 

# line 1 "LLC code (/src/parser/llc_src/forall/forall_comm_res_unit.src)" 
		/*  START CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_comm_res_unit.src'  */

	{ 	
		/* i => Variable del bucle
		 * 0 => Valor inicial de la variable del bucle
		 * ((np) - 1) => Valor final de la variable del bucle
		 */

		if (llc_case == LLC_BLOCK) {
			register int llc_i, llc_j;
	  	MPI_Status llc_status;
			char *llc_buf = NULL, *llc_buf_ptr = NULL;
			long llc_buf_size = 0, llc_size_tmp = 0;

		 	
			llc_buf_size = 0;
	 	  for(llc_i = 0; llc_i < LLC_NUMPROCESSORS; llc_i++) {
				llc_size_tmp = 0;

			 	for(llc_j = 0, i = (0) + llc_F[llc_i]; llc_j < LLC_PROCSGRP(llc_i); llc_j++, i++) {
					llc_size_tmp += (1) * sizeof ((&pos[i])[0]);
					llc_size_tmp += (1) * sizeof ((&vel[i])[0]);
					llc_size_tmp += (1) * sizeof ((&a[i])[0]);
				}
				llc_buf_size = LLC_MAX(llc_buf_size, llc_size_tmp);
			}

			if (llc_buf_size > 0) {

				LLC_CHECK_MALLOC (llc_buf, llc_buf_size, char);
	 			
	 	    for(llc_i = 0; llc_i < LLC_NUMPROCESSORS; llc_i++) {

					if (llc_i == LLC_NAME) {

						llc_buf_ptr = llc_buf;

			 			for(llc_j = 0, i = (0) + llc_F[llc_i]; llc_j < LLC_PROCSGRP(llc_i); llc_j++, i++) {
							    /* Packing &pos[i]... */
							memcpy (llc_buf_ptr, &pos[i], (1) * sizeof ((&pos[i])[0]));
							llc_buf_ptr += (1) * sizeof ((&pos[i])[0]);

							    /* Packing &vel[i]... */
							memcpy (llc_buf_ptr, &vel[i], (1) * sizeof ((&vel[i])[0]));
							llc_buf_ptr += (1) * sizeof ((&vel[i])[0]);

							    /* Packing &a[i]... */
							memcpy (llc_buf_ptr, &a[i], (1) * sizeof ((&a[i])[0]));
							llc_buf_ptr += (1) * sizeof ((&a[i])[0]);

						}
	  	      
						MPI_Bcast(llc_buf, (llc_buf_ptr - llc_buf), MPI_BYTE, llc_i, *llc_CurrentGroup);
						
					}
					else {
						
						llc_size_tmp = 0;
			 			for(llc_j = 0, i = (0) + llc_F[llc_i]; llc_j < LLC_PROCSGRP(llc_i); llc_j++, i++) {
							llc_size_tmp += (1) * sizeof ((&pos[i])[0]);
							llc_size_tmp += (1) * sizeof ((&vel[i])[0]);
							llc_size_tmp += (1) * sizeof ((&a[i])[0]);
						}
						
						MPI_Bcast(llc_buf, llc_size_tmp, MPI_BYTE, llc_i, *llc_CurrentGroup);
							
						llc_buf_ptr = llc_buf;

			 			for(llc_j = 0, i = (0) + llc_F[llc_i]; llc_j < LLC_PROCSGRP(llc_i); llc_j++, i++) {
							    /* Unpacking &pos[i]... */
							memcpy (&pos[i], llc_buf_ptr, (1) * sizeof ((&pos[i])[0]));
							llc_buf_ptr += (1) * sizeof ((&pos[i])[0]);

							    /* Unpacking &vel[i]... */
							memcpy (&vel[i], llc_buf_ptr, (1) * sizeof ((&vel[i])[0]));
							llc_buf_ptr += (1) * sizeof ((&vel[i])[0]);

							    /* Unpacking &a[i]... */
							memcpy (&a[i], llc_buf_ptr, (1) * sizeof ((&a[i])[0]));
							llc_buf_ptr += (1) * sizeof ((&a[i])[0]);

						}
					}
	     	}
	 			free (llc_buf);
			}
		}
		else {
			if (llc_case == LLC_GROUPS) {
				register int llc_i, llc_j, llc_k;
		  	MPI_Status llc_status;
				char *llc_buf = NULL, *llc_buf_ptr = NULL;
				long llc_buf_size = 0, llc_size_tmp = 0;
				int llc_my_name = LLC_NAME - llc_F[llc_grp];
	     	int llc_src;
			
				llc_buf_size = 0;
				for (i = (0); i <= (((np) - 1)); (i)++) {
					llc_size_tmp = 0;
					llc_size_tmp += (1) * sizeof ((&pos[i])[0]);
					llc_size_tmp += (1) * sizeof ((&vel[i])[0]);
					llc_size_tmp += (1) * sizeof ((&a[i])[0]);
					llc_buf_size = LLC_MAX(llc_buf_size, llc_size_tmp);
				}

				if (llc_buf_size > 0) {

					LLC_CHECK_MALLOC (llc_buf, llc_buf_size, char);
	 											 
		      for(llc_i = 0; llc_i < llc_nT; llc_i++) {
	  	      if(llc_i == llc_grp) {
	    	      for(llc_j = 0; llc_j < llc_nT; llc_j++) {
	      	      if(llc_j != llc_grp) {
									
									i = (0) + llc_grp;
									llc_buf_ptr = llc_buf;

									    /* Packing &pos[i]... */
									memcpy (llc_buf_ptr, &pos[i], (1) * sizeof ((&pos[i])[0]));
									llc_buf_ptr += (1) * sizeof ((&pos[i])[0]);

									    /* Packing &vel[i]... */
									memcpy (llc_buf_ptr, &vel[i], (1) * sizeof ((&vel[i])[0]));
									llc_buf_ptr += (1) * sizeof ((&vel[i])[0]);

									    /* Packing &a[i]... */
									memcpy (llc_buf_ptr, &a[i], (1) * sizeof ((&a[i])[0]));
									llc_buf_ptr += (1) * sizeof ((&a[i])[0]);


									for(llc_k = llc_my_name; llc_k < LLC_PROCSGRP(llc_j); llc_k += LLC_PROCSGRP(llc_grp)) {     
		
	      	          MPI_Send(llc_buf, (llc_buf_ptr - llc_buf), MPI_BYTE, llc_F[llc_j] + llc_k, llc_grp,
	          	               *llc_CurrentGroup);
		              }
	    	        }
	      	    }
	        	}
		        else {
	 				 		llc_src = llc_F[llc_i] + ((llc_my_name) % LLC_PROCSGRP(llc_i));     
						
							i = (0) + llc_i;
							llc_size_tmp = 0;
							llc_size_tmp += (1) * sizeof ((&pos[i])[0]);
							llc_size_tmp += (1) * sizeof ((&vel[i])[0]);
							llc_size_tmp += (1) * sizeof ((&a[i])[0]);
							
	  	        MPI_Recv(llc_buf, llc_size_tmp, MPI_BYTE, llc_src,
	    	               llc_i, *llc_CurrentGroup, &llc_status);
							
							llc_buf_ptr = llc_buf;
						
							    /* Unpacking &pos[i]... */
							memcpy (&pos[i], llc_buf_ptr, (1) * sizeof ((&pos[i])[0]));
							llc_buf_ptr += (1) * sizeof ((&pos[i])[0]);

							    /* Unpacking &vel[i]... */
							memcpy (&vel[i], llc_buf_ptr, (1) * sizeof ((&vel[i])[0]));
							llc_buf_ptr += (1) * sizeof ((&vel[i])[0]);

							    /* Unpacking &a[i]... */
							memcpy (&a[i], llc_buf_ptr, (1) * sizeof ((&a[i])[0]));
							llc_buf_ptr += (1) * sizeof ((&a[i])[0]);

			
	    	    }
	      	}
		 			free (llc_buf);
				}
			}
		}
	}



		/*  END CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_comm_res_unit.src'  */


# line 139 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 

# line 1 "LLC code (/src/parser/llc_src/forall/forall_exit.src)" 
		/*  START CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_exit.src'  */

	if ((llc_case == LLC_GROUPS) || (llc_case == LLC_BLOCK)) {
	  free(llc_F);
	  llc_F = NULL;

		if (llc_nc_result_list.num_var > 0) {
		  llc_nc_result_destroy_var_list ();
		}
	}



		/*  END CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_exit.src'  */


# line 139 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 

# line 139 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 

}



# line 145 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 
void compute (int np, int nd, real8 *box, vnd_t *pos, vnd_t *vel, real8 mass, vnd_t *f, real8 *pot_p, real8 *kin_p) {
  int i, j, k;
  vnd_t rij;
  real8 d;
  real8 pot, kin;
  
  pot = 0.0;
  kin = 0.0;
  
# line 1 "LLC code (/src/parser/llc_src/forall/forall_init_unit.src)" 
		/*  START CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_init_unit.src'  */

	{	
	  /* i => Variable del bucle
	   * 0 => Valor inicial de la variable del bucle
	   * ((np) - 1) => Valor final de la variable del bucle
	   * 1 => Peso(s)
		 * LLC_NO_WEIGHTS => Flags de asignacin equitativa por pesos (LLC_WEIGHTS/LLC_NO_WEIGHTS)
		 */
	  if(LLC_NUMPROCESSORS == 1) {
	    llc_case = LLC_SEQUENTIAL;
	  }
	  else {
			if ((llc_nT = ((((np) - 1)) - (0) + 1)) >= LLC_NUMPROCESSORS) {
	  	 	register int llc_i, llc_j, llc_k;
				int llc_rnT, llc_w, llc_mW;

	  		llc_case = LLC_BLOCK;

				if ((LLC_NO_WEIGHTS) == LLC_WEIGHTS) {

							/* begin: LLC_WEIGHTS */
		    /* Obtain medium weight (only weight > 0) */
	  	    for(llc_mW = 0, i = 0; i <= ((np) - 1); i++) {
				  	if ((1) > 0) {
							llc_mW += (1);
						}
					}
					llc_mW /= LLC_NUMPROCESSORS;

		   		LLC_CHECK_MALLOC (llc_F, (LLC_NUMPROCESSORS + 1), int);
					llc_F[0] = 0;
					llc_rnT = llc_nT - LLC_NUMPROCESSORS;
		
					/* Weighted task assignement */
					i = 0;
	  	 		for(llc_i = 0; llc_i < LLC_NUMPROCESSORS; llc_i++) {
						llc_F[llc_i + 1] = llc_F[llc_i] + 1;
						llc_w = 1;
						i++;
						while ((llc_rnT > 0) && (llc_w < (llc_mW + LLC_WEIGHT_TOL))) {
							llc_F[llc_i + 1]++;
							llc_w += 1;
							i++;
							llc_rnT--;
						}
					}

					llc_i = 0;			/* Unassigned tasks: Cyclic assignment */
					while (llc_rnT > 0) {
						llc_F[(llc_i % LLC_NUMPROCESSORS) + 1]++;
						llc_rnT--;
						llc_i++;
					}
		 		}  			/* end: LLC_WEIHGTS */
				else {
								/* begin: LLC_NO_WEIGHTS */
					register int llc_i;
					/* Medium number of tasks */
					int llc_meanT = llc_nT / LLC_NUMPROCESSORS;
					/* Number of unassigned tasks */
					int llc_rnT = llc_nT % LLC_NUMPROCESSORS;
		   		
					LLC_CHECK_MALLOC (llc_F, (LLC_NUMPROCESSORS + 1), int);
					
					llc_F[0] = 0;
					for (llc_i = 1; llc_i < (LLC_NUMPROCESSORS + 1); llc_i++) { 
						llc_F[llc_i] = llc_F[llc_i-1] + llc_meanT + (((llc_i - 1) < llc_rnT) ? 1 : 0);
					}
				} 			/* end: LLC_NO_WEIGHTS */
				
			} /* LLC_BLOCK */
	  	else if(llc_nT > 0) {
				llc_case = LLC_GROUPS;
				
				if ((LLC_NO_WEIGHTS) == LLC_WEIGHTS) {
	  	 		register int llc_i, llc_j, llc_k;
	 	 			int *llc_ptr;
					int *llc_W, llc_nW;
	  			int *llc_P, llc_nP;
	  			int *llc_G;
	 
							/* begin: LLC_WEIGHTS */


	    	/* ------------------------------------------------------------
	      	 Weights processing: Threads with non-possitive weight are
		       discarded
	  	     ------------------------------------------------------------ */

					LLC_CHECK_MALLOC (llc_ptr, 3 * llc_nT, int);
					llc_W = llc_ptr;
					llc_P = llc_ptr + llc_nT;
					llc_G = llc_ptr + (2 * llc_nT);

			  	llc_k = llc_nP = LLC_NUMPROCESSORS - llc_nT + 1;
	    		for(llc_nW = 0, llc_i = 0, i = (0); i <= (((np) - 1)); i++, llc_i++) {
		      	if((llc_W[llc_i] = (1)) > 0) {
	  	      	llc_nW += llc_W[llc_i];
	    	    	if(llc_W[llc_i] < llc_k) llc_k = llc_W[llc_i];
	      		}
		      	else
	  	      	llc_W[llc_i] = 0;
	    		}

		    	/* Weights normalization */
		
	  	  	if(llc_k < llc_nP)
	    	  	for(llc_i = 0; llc_i < llc_nT; llc_i++) {
	      		 	llc_W[llc_i] *= llc_nP;
		        	llc_W[llc_i] /= llc_k;
	  	    	}

		    	/* ------------------------------------------------------------
	  	     	Processors assigment policy: BLOCK
	    	   	At least one processor by thread
	      	 	------------------------------------------------------------ */

		   		for(llc_i = 0; llc_i < llc_nT; llc_i++) {
	  	    	llc_P[llc_i] = 1;

		      	llc_j = llc_i;
	  	    	while((llc_j > 0) && (llc_W[llc_i] > llc_W[llc_G[llc_j - 1]])) {
	    	    	llc_G[llc_j] = llc_G[llc_j - 1];
	      	  	llc_j--;
		      	}
	  	    	llc_G[llc_j] = llc_i;
	    		}

		    	llc_nP = llc_nT;
	  	  	while(llc_nP++ < LLC_NUMPROCESSORS) {
	    	  	llc_W[llc_G[0]] = (llc_W[llc_G[0]] * llc_P[llc_G[0]]) /
	      	                (llc_P[llc_G[0]] + 1);
	      		llc_P[llc_G[0]]++;
		      	llc_k = llc_G[0];
	  	    	llc_j = 1;
	    	  	while((llc_j < llc_nT) && (llc_W[llc_G[llc_j]] > llc_W[llc_G[llc_j-1]])) {
	      	  	llc_G[llc_j-1] = llc_G[llc_j];
		        	llc_j++;
	  	    	}
	    	  	llc_G[llc_j-1] = llc_k;
		    	}

	  	  	/* ------------------------------------------------------------
	    	  	 Groups creation
		    	   ------------------------------------------------------------ */

					LLC_CHECK_MALLOC (llc_F, (llc_nT + 1), int);
	  	  	
					llc_F[0] = 0;
	    		for(llc_i = 1; llc_i <= llc_nT; llc_i++)
		      	llc_F[llc_i] = llc_F[llc_i-1] + llc_P[llc_i-1];
	  	                                                    		

	  	  	/* ------------------------------------------------------------
							Auxiliar variables deallocation
		    	   ------------------------------------------------------------ */

		    	free(llc_ptr);
		 		}  			/* end: LLC_WEIHGTS */
				else {
								/* begin: LLC_NO_WEIGHTS */

					register int llc_i;
					/* Medium number of processors */
					int llc_meanP = LLC_NUMPROCESSORS / llc_nT;
					/* Number of unassigned processors */
					int llc_rnP = LLC_NUMPROCESSORS % llc_nT;
		   		
					LLC_CHECK_MALLOC (llc_F, (llc_nT + 1), int);
					
					llc_F[0] = 0;
					for (llc_i = 1; llc_i < (llc_nT + 1); llc_i++) { 	
						llc_F[llc_i] = llc_F[llc_i-1] + llc_meanP + (((llc_i - 1) < llc_rnP) ? 1 : 0);
		
					}
		
				} 			/* end: LLC_NO_WEIGHTS */

	  	  /* Get the group name */
	  	  llc_grp = 0;
	 	  	while(LLC_NAME >= llc_F[llc_grp+1]) llc_grp++;
				
			} /* LLC_GROUPS */
	  	else llc_case = LLC_ERROR_CASE;
		}
	}




		/*  END CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_init_unit.src'  */


# line 177 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 

# line 1 "LLC code (/src/parser/llc_src/forall/forall_exec_unit.src)" 
		/*  START CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_exec_unit.src'  */

	{
		/* i => Variable del bucle
		 * 0 => Valor inicial de la variable del bucle
		 * ((np) - 1) => Valor final de la variable del bucle
		 * dolar3 => Bloque del bucle
		 */
		
	  int llc_case_save = llc_case;

	  switch(llc_case) {
	    case LLC_SEQUENTIAL:
	      for(i = (0); i <= (((np) - 1)); (i)++)
	         {
    for (j = 0; j < nd; j++)
      f[i][j] = 0.0;
    
    for (j = 0; j < np; j++) {
      if (i != j) {
        d = dist (nd, box, pos[i], pos[j], rij);
        pot = pot + 0.5 * v (d);
        for (k = 0; k < nd; k++) {
          f[i][k] = f[i][k] - rij[k] * dv (d) / d;
        }
      }
    }
    kin = kin + dotr8 (nd, vel[i], vel[j]);
  };
	    break;
	    case LLC_BLOCK:
				{
				  int llc_nP;
					register int llc_i;
				  int llc_nT_save;
				  int llc_grp_save;
					llc_var_reg_data llc_nc_result_list_save;

	 	     	llc_nP = LLC_NUMPROCESSORS;
					llc_grp_save = LLC_NAME;
		      LLC_NUMPROCESSORS = 1;
	  	    LLC_NAME = 0;
	/*				llc_nc_result_list_save_copy (llc_nc_result_list_save); */

					i = (0) + llc_F[llc_grp_save];
					for(llc_i = 0; llc_i < LLC_PROCSGRP(llc_grp_save); llc_i++, i++) {
						 {
    for (j = 0; j < nd; j++)
      f[i][j] = 0.0;
    
    for (j = 0; j < np; j++) {
      if (i != j) {
        d = dist (nd, box, pos[i], pos[j], rij);
        pot = pot + 0.5 * v (d);
        for (k = 0; k < nd; k++) {
          f[i][k] = f[i][k] - rij[k] * dv (d) / d;
        }
      }
    }
    kin = kin + dotr8 (nd, vel[i], vel[j]);
  };
					}
					
	/*	      if (llc_nc_result_list.num_var > 0) {
	        	llc_nc_result_destroy_var_list();
					}
	        llc_nc_result_list = llc_nc_result_list_save; */
	  	   	LLC_NAME = llc_grp_save;
	    	 	LLC_NUMPROCESSORS = llc_nP;
				}
		    break;

	    case LLC_GROUPS:
				{	
					MPI_Comm *llc_AuxGroup, llc_SubGroup;
				  int llc_nT_save;
				  int llc_grp_save;
				  int *llc_F_save;
					llc_var_reg_data llc_nc_result_list_save;


		      LLC_NAME -= llc_F[llc_grp];
	  	    LLC_NUMPROCESSORS = llc_F[llc_grp+1] - llc_F[llc_grp];
		      MPI_Comm_split(*llc_CurrentGroup, llc_grp, LLC_NAME, &llc_SubGroup);
	  	    llc_AuxGroup = llc_CurrentGroup;
	    	  llc_CurrentGroup = &llc_SubGroup;
	      	llc_nT_save = llc_nT;
		      llc_grp_save = llc_grp;
	  	    llc_F_save = llc_F;
	/*				llc_nc_result_list_save_copy (llc_nc_result_list_save); */
	        

	    	  i = (0) + llc_grp;
					 {
    for (j = 0; j < nd; j++)
      f[i][j] = 0.0;
    
    for (j = 0; j < np; j++) {
      if (i != j) {
        d = dist (nd, box, pos[i], pos[j], rij);
        pot = pot + 0.5 * v (d);
        for (k = 0; k < nd; k++) {
          f[i][k] = f[i][k] - rij[k] * dv (d) / d;
        }
      }
    }
    kin = kin + dotr8 (nd, vel[i], vel[j]);
  };

	/*        if (llc_nc_result_list.num_var > 0) {
	        	llc_nc_result_destroy_var_list();
					}
	        llc_nc_result_list = llc_nc_result_list_save; */
		      llc_F = llc_F_save;
	  	    llc_grp = llc_grp_save;
	    	  llc_nT = llc_nT_save;
		      LLC_NUMPROCESSORS = llc_F[llc_nT];
	  	    LLC_NAME += llc_F[llc_grp];
	    	  llc_CurrentGroup = llc_AuxGroup;
	      	MPI_Comm_free(&llc_SubGroup);
				}
		    break;
	  	}
	  llc_case = llc_case_save;
	}



		/*  END CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_exec_unit.src'  */


# line 177 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 

# line 1 "LLC code (/src/parser/llc_src/forall/forall_comm_unit.src)" 
		/*  START CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_comm_unit.src'  */

	{ 	
		/* i => Variable del bucle
		 * 0 => Valor inicial de la variable del bucle
		 * ((np) - 1) => Valor final de la variable del bucle
		 */

		if (llc_case == LLC_BLOCK) {
			register int llc_i, llc_j;
	  	MPI_Status llc_status;
			char *llc_buf = NULL, *llc_buf_ptr = NULL;
			long llc_buf_size = 0, llc_size_tmp = 0;

		 	
			llc_buf_size = 0;

			if (llc_nT > LLC_NUMPROCESSORS) {	
	  	  for(llc_i = 0; llc_i < LLC_NUMPROCESSORS; llc_i++) {
					llc_size_tmp = 0;
					for(llc_j = 0, i = (0) + llc_F[llc_i]; llc_j < LLC_PROCSGRP(llc_i); llc_j++, i++) {    
						llc_size_tmp += (1) * sizeof ((&f[i])[0]);
					}
					llc_buf_size = LLC_MAX(llc_buf_size, llc_size_tmp);
				}
			}
				
			if ((llc_buf_size > 0) || (llc_nT == LLC_NUMPROCESSORS)) {

				if (llc_buf_size > 0) {
					LLC_CHECK_MALLOC (llc_buf, llc_buf_size, char);
				}

	 	    for(llc_i = 0; llc_i < LLC_NUMPROCESSORS; llc_i++) {

					if (llc_i == LLC_NAME) {

						if (LLC_PROCSGRP(llc_i) == 1) {		/* Simple element. Don't pack */
							i = (0) + llc_F[llc_i];
							MPI_Bcast(&f[i], ((1) * sizeof((&f[i])[0])), MPI_BYTE, llc_i, *llc_CurrentGroup);
						}
						else {				/* Multiple elements. Pack */
							llc_buf_ptr = llc_buf;

							for(llc_j = 0, i = (0) + llc_F[llc_i]; llc_j < LLC_PROCSGRP(llc_i); llc_j++, i++) {    
								    /* Packing &f[i]... */
								memcpy (llc_buf_ptr, &f[i], (1) * sizeof ((&f[i])[0]));
								llc_buf_ptr += (1) * sizeof ((&f[i])[0]);

							}
	  	      
							MPI_Bcast(llc_buf, (llc_buf_ptr - llc_buf), MPI_BYTE, llc_i, *llc_CurrentGroup);
						}
					}
					else {

						if (LLC_PROCSGRP(llc_i) == 1) {		/* Simple element. Don't unpack */
							i = (0) + llc_F[llc_i];
							MPI_Bcast(&f[i], ((1) * sizeof((&f[i])[0])), MPI_BYTE, llc_i, *llc_CurrentGroup);
						}
						else {				/* Multiple elements. Unpack */

							llc_size_tmp = 0;

							for(llc_j = 0, i = (0) + llc_F[llc_i]; llc_j < LLC_PROCSGRP(llc_i); llc_j++, i++) {    
								llc_size_tmp += (1) * sizeof ((&f[i])[0]);
							}
						
							MPI_Bcast(llc_buf, llc_size_tmp, MPI_BYTE, llc_i, *llc_CurrentGroup);
						
							llc_buf_ptr = llc_buf;

							for(llc_j = 0, i = (0) + llc_F[llc_i]; llc_j < LLC_PROCSGRP(llc_i); llc_j++, i++) {    
								    /* Unpacking &f[i]... */
								memcpy (&f[i], llc_buf_ptr, (1) * sizeof ((&f[i])[0]));
								llc_buf_ptr += (1) * sizeof ((&f[i])[0]);

							}
						}
					}
	     	}
	 			free (llc_buf);
			}
		}
		else {
			if (llc_case == LLC_GROUPS) {
				int llc_my_name = LLC_NAME - llc_F[llc_grp];
				int llc_src;
				register int llc_i, llc_j, llc_k;
	 	 		MPI_Status llc_status;
				char *llc_buf = NULL, *llc_buf_ptr = NULL;
				long llc_buf_size = 0, llc_size_tmp = 0;


	      for(llc_i = 0; llc_i < llc_nT; llc_i++) {
	 	      if(llc_i == llc_grp) {
	   	      for(llc_j = 0; llc_j < llc_nT; llc_j++) {
	     	      if(llc_j != llc_grp) {
	 	    	  		i = (0) + llc_grp;
	         	    for(llc_k = llc_my_name; llc_k < LLC_PROCSGRP(llc_j); llc_k += LLC_PROCSGRP(llc_grp)) {
	     	          MPI_Send((&f[i]), (1) * sizeof((&f[i])[0]), MPI_BYTE, llc_F[llc_j] + llc_k, 
																																					llc_grp, *llc_CurrentGroup);
	              }
	 	          }
	   	      }
	     	  }
	       	else {
						llc_src = llc_F[llc_i] + ((llc_my_name) % LLC_PROCSGRP(llc_i));
	         	i = (0) + llc_i; 
	    	    MPI_Recv((&f[i]), (1) * sizeof((&f[i])[0]), MPI_BYTE, llc_src, llc_i, *llc_CurrentGroup, &llc_status);
	       	}
				}
	    }
		}
	}



		/*  END CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_comm_unit.src'  */


# line 177 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 

# line 1 "LLC code (/src/parser/llc_src/forall/forall_comm_red.src)" 
		/*  START CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_comm_red.src'  */

	{
		if ((llc_case == LLC_BLOCK) || (llc_case == LLC_GROUPS)) {
			register int llc_i, llc_k;
			char *llc_buf = NULL, *llc_buf_ptr = NULL, *llc_buf_tmp = NULL;
			int llc_buf_size, llc_size_tmp;
	  	MPI_Status llc_status;
				
			llc_buf_size = 0;

			llc_buf_size += sizeof (real8);
			llc_buf_size += sizeof (real8);

			if (llc_buf_size > 0) {

	  	 	LLC_CHECK_MALLOC (llc_buf, llc_buf_size, char);
	  	
				if (llc_case == LLC_BLOCK) {
		
					if (LLC_NAME == 0) {
											 
	  				for (llc_i = 1; llc_i < LLC_NUMPROCESSORS; llc_i++) {
									
							MPI_Recv (llc_buf, llc_buf_size, MPI_BYTE, llc_i, LLC_TAG_REDUCE_DATA, 
																																*llc_CurrentGroup, &llc_status);
					
							llc_buf_ptr = llc_buf;

							pot += (*(real8 *) llc_buf_ptr);
							llc_buf_ptr +=  sizeof(real8);
							kin += (*(real8 *) llc_buf_ptr);
							llc_buf_ptr +=  sizeof(real8);
						}
					


						llc_buf_ptr = llc_buf;

						memcpy (llc_buf_ptr, &pot, sizeof(real8));
						llc_buf_ptr += sizeof(real8);
						memcpy (llc_buf_ptr, &kin, sizeof(real8));
						llc_buf_ptr += sizeof(real8);

						MPI_Bcast (llc_buf, llc_buf_size, MPI_BYTE, 0, *llc_CurrentGroup);

					}
					else {

						llc_buf_ptr = llc_buf;

						memcpy (llc_buf_ptr, &pot, sizeof(real8));
						llc_buf_ptr += sizeof(real8);
						memcpy (llc_buf_ptr, &kin, sizeof(real8));
						llc_buf_ptr += sizeof(real8);
					
						MPI_Send (llc_buf, llc_buf_size, MPI_BYTE, 0, LLC_TAG_REDUCE_DATA, *llc_CurrentGroup);


						MPI_Bcast (llc_buf, llc_buf_size, MPI_BYTE, 0, *llc_CurrentGroup);
				
						llc_buf_ptr = llc_buf;

						memcpy (&pot, llc_buf_ptr, sizeof(real8));
						llc_buf_ptr += sizeof(real8);
						memcpy (&kin, llc_buf_ptr, sizeof(real8));
						llc_buf_ptr += sizeof(real8);
					}
				}
				else {
					if (llc_case == LLC_GROUPS) {
		
						if (LLC_NAME == 0) {

							for (llc_i = 1; llc_i < llc_nT; llc_i++) {
								
			  				MPI_Recv (llc_buf, llc_buf_size, MPI_BYTE, llc_F[llc_i], LLC_TAG_REDUCE_DATA, 
																																*llc_CurrentGroup, &llc_status);
							
								llc_buf_ptr = llc_buf;

								pot += (*(real8 *) llc_buf_ptr);
								llc_buf_ptr +=  sizeof(real8);
								kin += (*(real8 *) llc_buf_ptr);
								llc_buf_ptr +=  sizeof(real8);
							}

							llc_buf_ptr = llc_buf;

							memcpy (llc_buf_ptr, &pot, sizeof(real8));
							llc_buf_ptr += sizeof(real8);
							memcpy (llc_buf_ptr, &kin, sizeof(real8));
							llc_buf_ptr += sizeof(real8);
					

							MPI_Bcast (llc_buf, llc_buf_size, MPI_BYTE, 0, *llc_CurrentGroup);	
						}
						else {
							for (llc_i = 1; llc_i < llc_nT; llc_i++) {
						
								if (LLC_NAME == llc_F[llc_i]) {
							
									llc_buf_ptr = llc_buf;

									memcpy (llc_buf_ptr, &pot, sizeof(real8));
									llc_buf_ptr += sizeof(real8);
									memcpy (llc_buf_ptr, &kin, sizeof(real8));
									llc_buf_ptr += sizeof(real8);

									MPI_Send (llc_buf, llc_buf_size, MPI_BYTE, 0, LLC_TAG_REDUCE_DATA, *llc_CurrentGroup);
		
									break;
		
								}
							}
						
							MPI_Bcast (llc_buf, llc_buf_size, MPI_BYTE, 0, *llc_CurrentGroup);
					
						llc_buf_ptr = llc_buf;

						memcpy (&pot, llc_buf_ptr, sizeof(real8));
						llc_buf_ptr += sizeof(real8);
						memcpy (&kin, llc_buf_ptr, sizeof(real8));
						llc_buf_ptr += sizeof(real8);

							
						}
				
				
					}
				}
				free (llc_buf);
				free (llc_buf_tmp);
			}
		}
	}




		/*  END CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_comm_red.src'  */


# line 177 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 

# line 1 "LLC code (/src/parser/llc_src/forall/forall_exit.src)" 
		/*  START CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_exit.src'  */

	if ((llc_case == LLC_GROUPS) || (llc_case == LLC_BLOCK)) {
	  free(llc_F);
	  llc_F = NULL;

		if (llc_nc_result_list.num_var > 0) {
		  llc_nc_result_destroy_var_list ();
		}
	}



		/*  END CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_exit.src'  */


# line 177 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 

# line 177 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 

  kin = kin * 0.5 * mass;
  *pot_p = pot;
  *kin_p = kin;
}



# line 189 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 

# line 1 "LLC code (MAIN)" 

	/* LLC Autogenerated main */

int main (int argc, char **argv) {
	int llc_return_code = 0;

	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, (int*)&LLC_GLOBAL_NAME);
	MPI_Comm_size(MPI_COMM_WORLD, (int*)&LLC_GLOBAL_NUMPROCESSORS);
	LLC_NAME = LLC_GLOBAL_NAME;
	LLC_NUMPROCESSORS = LLC_GLOBAL_NUMPROCESSORS;
	llc_GlobalGroup = MPI_COMM_WORLD;
	llc_CurrentGroup = &llc_GlobalGroup;

	llc_return_code = llc_main (argc, argv);

	MPI_Finalize();
	return llc_return_code;
}




# line 189 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MD/MD-LLCOMP/md_result_llcomp.c" 
int llc_main (int argc, char **argv) {
  real8 mass = 1.0;
  real8 dt = 1.0e-4;
  vnd_t box;
  vnd_t position [nparts];
  vnd_t velocity [nparts];
  vnd_t force [nparts];
  vnd_t accel [nparts];
  real8 potential, kinetic, E0;
  int i;
  double t0, t1;
  
  for (i = 0; i < ndim; i++)
    box[i] = 10.0;
  
  initialize (nparts, ndim, box, position, velocity, accel);
  t0 = t ();
  compute (nparts, ndim, box, position, velocity, mass, force, &potential, &kinetic);
  E0 = potential + kinetic;
  for (i = 0; i < nsteps; i++) {
    compute (nparts, ndim, box, position, velocity, mass, force, &potential, &kinetic);
    update (nparts, ndim, position, velocity, force, accel, mass, dt);
  }
  t1 = t ();
  llc_time = t1 - t0;
  printf ("%d:%f:[parts = %d dim = %d steps = %d]\n", LLC_NAME, llc_time, nparts, ndim, nsteps);
  return (0);
}





/*
 * vim:ts=2:sw=2:
 */

