
#include "llc.h"


# line 1 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MxM/MxM-LLCOMP/mxm_llcomp.c" 
#include <stdio.h>
int llc_main (int argc, char *argv []);
void r8_mxm (int l, int m, int n);
double r8_uniform_01 (int *seed);

# line 1 "LLC code (MAIN)" 

	/* LLC Autogenerated main */

int main (int argc, char **argv) {
	int llc_return_code = 0;

	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, (int*)&LLC_GLOBAL_NAME);
	MPI_Comm_size(MPI_COMM_WORLD, (int*)&LLC_GLOBAL_NUMPROCESSORS);
	LLC_NAME = LLC_GLOBAL_NAME;
	LLC_NUMPROCESSORS = LLC_GLOBAL_NUMPROCESSORS;
	llc_GlobalGroup = MPI_COMM_WORLD;
	llc_CurrentGroup = &llc_GlobalGroup;

	llc_return_code = llc_main (argc, argv);

	MPI_Finalize();
	return llc_return_code;
}




# line 21 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MxM/MxM-LLCOMP/mxm_llcomp.c" 
int llc_main (int argc, char *argv []) {
  int l = 500, m = 500, n = 500;
  
  r8_mxm (l, m, n);
  return 0;
}



# line 80 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MxM/MxM-LLCOMP/mxm_llcomp.c" 
double r8_uniform_01 (int *seed) {
  int k;
  double r;
  
  k = *seed / 127773;
  *seed = 16807 * (*seed - k * 127773) - k * 2836;
  if (*seed < 0)
    *seed = *seed + 2147483647;
  
  r = (double) (*seed) * 4.656612875E-10;
  return r;
}



# line 112 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MxM/MxM-LLCOMP/mxm_llcomp.c" 
void r8_mxm (int l, int m, int n) {
  double *a;
  double *b;
  double *c;
  int i;
  int j;
  int k;
  double R;
  int seed;
  int MPI_NAME, MPI_NUMPROCESSORS;
  struct timeval start_time, end_time;
  double time;
  
  b = (double *) malloc (l * m * sizeof (double));
  a = (double *) malloc (m * n * sizeof (double));
  c = (double *) malloc (l * n * sizeof (double));
  seed = 123456789;
  for (k = 0; k < (l * m); k++)
    a[k] = r8_uniform_01 (&seed);
  
  for (k = 0; k < (m * n); k++)
    b[k] = r8_uniform_01 (&seed);
  
  gettimeofday (&start_time, 0);
  
# line 1 "LLC code (/src/parser/llc_src/forall/forall_init_unit.src)" 
		/*  START CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_init_unit.src'  */

	{	
	  /* j => Variable del bucle
	   * 0 => Valor inicial de la variable del bucle
	   * ((n) - 1) => Valor final de la variable del bucle
	   * 1 => Peso(s)
		 * LLC_NO_WEIGHTS => Flags de asignacin equitativa por pesos (LLC_WEIGHTS/LLC_NO_WEIGHTS)
		 */
	  if(LLC_NUMPROCESSORS == 1) {
	    llc_case = LLC_SEQUENTIAL;
	  }
	  else {
			if ((llc_nT = ((((n) - 1)) - (0) + 1)) >= LLC_NUMPROCESSORS) {
	  	 	register int llc_i, llc_j, llc_k;
				int llc_rnT, llc_w, llc_mW;

	  		llc_case = LLC_BLOCK;

				if ((LLC_NO_WEIGHTS) == LLC_WEIGHTS) {

							/* begin: LLC_WEIGHTS */
		    /* Obtain medium weight (only weight > 0) */
	  	    for(llc_mW = 0, j = 0; j <= ((n) - 1); j++) {
				  	if ((1) > 0) {
							llc_mW += (1);
						}
					}
					llc_mW /= LLC_NUMPROCESSORS;

		   		LLC_CHECK_MALLOC (llc_F, (LLC_NUMPROCESSORS + 1), int);
					llc_F[0] = 0;
					llc_rnT = llc_nT - LLC_NUMPROCESSORS;
		
					/* Weighted task assignement */
					j = 0;
	  	 		for(llc_i = 0; llc_i < LLC_NUMPROCESSORS; llc_i++) {
						llc_F[llc_i + 1] = llc_F[llc_i] + 1;
						llc_w = 1;
						j++;
						while ((llc_rnT > 0) && (llc_w < (llc_mW + LLC_WEIGHT_TOL))) {
							llc_F[llc_i + 1]++;
							llc_w += 1;
							j++;
							llc_rnT--;
						}
					}

					llc_i = 0;			/* Unassigned tasks: Cyclic assignment */
					while (llc_rnT > 0) {
						llc_F[(llc_i % LLC_NUMPROCESSORS) + 1]++;
						llc_rnT--;
						llc_i++;
					}
		 		}  			/* end: LLC_WEIHGTS */
				else {
								/* begin: LLC_NO_WEIGHTS */
					register int llc_i;
					/* Medium number of tasks */
					int llc_meanT = llc_nT / LLC_NUMPROCESSORS;
					/* Number of unassigned tasks */
					int llc_rnT = llc_nT % LLC_NUMPROCESSORS;
		   		
					LLC_CHECK_MALLOC (llc_F, (LLC_NUMPROCESSORS + 1), int);
					
					llc_F[0] = 0;
					for (llc_i = 1; llc_i < (LLC_NUMPROCESSORS + 1); llc_i++) { 
						llc_F[llc_i] = llc_F[llc_i-1] + llc_meanT + (((llc_i - 1) < llc_rnT) ? 1 : 0);
					}
				} 			/* end: LLC_NO_WEIGHTS */
				
			} /* LLC_BLOCK */
	  	else if(llc_nT > 0) {
				llc_case = LLC_GROUPS;
				
				if ((LLC_NO_WEIGHTS) == LLC_WEIGHTS) {
	  	 		register int llc_i, llc_j, llc_k;
	 	 			int *llc_ptr;
					int *llc_W, llc_nW;
	  			int *llc_P, llc_nP;
	  			int *llc_G;
	 
							/* begin: LLC_WEIGHTS */


	    	/* ------------------------------------------------------------
	      	 Weights processing: Threads with non-possitive weight are
		       discarded
	  	     ------------------------------------------------------------ */

					LLC_CHECK_MALLOC (llc_ptr, 3 * llc_nT, int);
					llc_W = llc_ptr;
					llc_P = llc_ptr + llc_nT;
					llc_G = llc_ptr + (2 * llc_nT);

			  	llc_k = llc_nP = LLC_NUMPROCESSORS - llc_nT + 1;
	    		for(llc_nW = 0, llc_i = 0, j = (0); j <= (((n) - 1)); j++, llc_i++) {
		      	if((llc_W[llc_i] = (1)) > 0) {
	  	      	llc_nW += llc_W[llc_i];
	    	    	if(llc_W[llc_i] < llc_k) llc_k = llc_W[llc_i];
	      		}
		      	else
	  	      	llc_W[llc_i] = 0;
	    		}

		    	/* Weights normalization */
		
	  	  	if(llc_k < llc_nP)
	    	  	for(llc_i = 0; llc_i < llc_nT; llc_i++) {
	      		 	llc_W[llc_i] *= llc_nP;
		        	llc_W[llc_i] /= llc_k;
	  	    	}

		    	/* ------------------------------------------------------------
	  	     	Processors assigment policy: BLOCK
	    	   	At least one processor by thread
	      	 	------------------------------------------------------------ */

		   		for(llc_i = 0; llc_i < llc_nT; llc_i++) {
	  	    	llc_P[llc_i] = 1;

		      	llc_j = llc_i;
	  	    	while((llc_j > 0) && (llc_W[llc_i] > llc_W[llc_G[llc_j - 1]])) {
	    	    	llc_G[llc_j] = llc_G[llc_j - 1];
	      	  	llc_j--;
		      	}
	  	    	llc_G[llc_j] = llc_i;
	    		}

		    	llc_nP = llc_nT;
	  	  	while(llc_nP++ < LLC_NUMPROCESSORS) {
	    	  	llc_W[llc_G[0]] = (llc_W[llc_G[0]] * llc_P[llc_G[0]]) /
	      	                (llc_P[llc_G[0]] + 1);
	      		llc_P[llc_G[0]]++;
		      	llc_k = llc_G[0];
	  	    	llc_j = 1;
	    	  	while((llc_j < llc_nT) && (llc_W[llc_G[llc_j]] > llc_W[llc_G[llc_j-1]])) {
	      	  	llc_G[llc_j-1] = llc_G[llc_j];
		        	llc_j++;
	  	    	}
	    	  	llc_G[llc_j-1] = llc_k;
		    	}

	  	  	/* ------------------------------------------------------------
	    	  	 Groups creation
		    	   ------------------------------------------------------------ */

					LLC_CHECK_MALLOC (llc_F, (llc_nT + 1), int);
	  	  	
					llc_F[0] = 0;
	    		for(llc_i = 1; llc_i <= llc_nT; llc_i++)
		      	llc_F[llc_i] = llc_F[llc_i-1] + llc_P[llc_i-1];
	  	                                                    		

	  	  	/* ------------------------------------------------------------
							Auxiliar variables deallocation
		    	   ------------------------------------------------------------ */

		    	free(llc_ptr);
		 		}  			/* end: LLC_WEIHGTS */
				else {
								/* begin: LLC_NO_WEIGHTS */

					register int llc_i;
					/* Medium number of processors */
					int llc_meanP = LLC_NUMPROCESSORS / llc_nT;
					/* Number of unassigned processors */
					int llc_rnP = LLC_NUMPROCESSORS % llc_nT;
		   		
					LLC_CHECK_MALLOC (llc_F, (llc_nT + 1), int);
					
					llc_F[0] = 0;
					for (llc_i = 1; llc_i < (llc_nT + 1); llc_i++) { 	
						llc_F[llc_i] = llc_F[llc_i-1] + llc_meanP + (((llc_i - 1) < llc_rnP) ? 1 : 0);
		
					}
		
				} 			/* end: LLC_NO_WEIGHTS */

	  	  /* Get the group name */
	  	  llc_grp = 0;
	 	  	while(LLC_NAME >= llc_F[llc_grp+1]) llc_grp++;
				
			} /* LLC_GROUPS */
	  	else llc_case = LLC_ERROR_CASE;
		}
	}




		/*  END CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_init_unit.src'  */


# line 158 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MxM/MxM-LLCOMP/mxm_llcomp.c" 

# line 1 "LLC code (/src/parser/llc_src/forall/forall_exec_unit.src)" 
		/*  START CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_exec_unit.src'  */

	{
		/* j => Variable del bucle
		 * 0 => Valor inicial de la variable del bucle
		 * ((n) - 1) => Valor final de la variable del bucle
		 * dolar3 => Bloque del bucle
		 */
		
	  int llc_case_save = llc_case;

	  switch(llc_case) {
	    case LLC_SEQUENTIAL:
	      for(j = (0); j <= (((n) - 1)); (j)++)
	         {
    for (i = 0; i < l; i++) {
      R = 0.0;
      for (k = 0; k < m; k++)
        R += b[i + k * l] * a[k + j * m];
      
      c[i + j * l] = R;
    }
  };
	    break;
	    case LLC_BLOCK:
				{
				  int llc_nP;
					register int llc_i;
				  int llc_nT_save;
				  int llc_grp_save;
					llc_var_reg_data llc_nc_result_list_save;

	 	     	llc_nP = LLC_NUMPROCESSORS;
					llc_grp_save = LLC_NAME;
		      LLC_NUMPROCESSORS = 1;
	  	    LLC_NAME = 0;
	/*				llc_nc_result_list_save_copy (llc_nc_result_list_save); */

					j = (0) + llc_F[llc_grp_save];
					for(llc_i = 0; llc_i < LLC_PROCSGRP(llc_grp_save); llc_i++, j++) {
						 {
    for (i = 0; i < l; i++) {
      R = 0.0;
      for (k = 0; k < m; k++)
        R += b[i + k * l] * a[k + j * m];
      
      c[i + j * l] = R;
    }
  };
					}
					
	/*	      if (llc_nc_result_list.num_var > 0) {
	        	llc_nc_result_destroy_var_list();
					}
	        llc_nc_result_list = llc_nc_result_list_save; */
	  	   	LLC_NAME = llc_grp_save;
	    	 	LLC_NUMPROCESSORS = llc_nP;
				}
		    break;

	    case LLC_GROUPS:
				{	
					MPI_Comm *llc_AuxGroup, llc_SubGroup;
				  int llc_nT_save;
				  int llc_grp_save;
				  int *llc_F_save;
					llc_var_reg_data llc_nc_result_list_save;


		      LLC_NAME -= llc_F[llc_grp];
	  	    LLC_NUMPROCESSORS = llc_F[llc_grp+1] - llc_F[llc_grp];
		      MPI_Comm_split(*llc_CurrentGroup, llc_grp, LLC_NAME, &llc_SubGroup);
	  	    llc_AuxGroup = llc_CurrentGroup;
	    	  llc_CurrentGroup = &llc_SubGroup;
	      	llc_nT_save = llc_nT;
		      llc_grp_save = llc_grp;
	  	    llc_F_save = llc_F;
	/*				llc_nc_result_list_save_copy (llc_nc_result_list_save); */
	        

	    	  j = (0) + llc_grp;
					 {
    for (i = 0; i < l; i++) {
      R = 0.0;
      for (k = 0; k < m; k++)
        R += b[i + k * l] * a[k + j * m];
      
      c[i + j * l] = R;
    }
  };

	/*        if (llc_nc_result_list.num_var > 0) {
	        	llc_nc_result_destroy_var_list();
					}
	        llc_nc_result_list = llc_nc_result_list_save; */
		      llc_F = llc_F_save;
	  	    llc_grp = llc_grp_save;
	    	  llc_nT = llc_nT_save;
		      LLC_NUMPROCESSORS = llc_F[llc_nT];
	  	    LLC_NAME += llc_F[llc_grp];
	    	  llc_CurrentGroup = llc_AuxGroup;
	      	MPI_Comm_free(&llc_SubGroup);
				}
		    break;
	  	}
	  llc_case = llc_case_save;
	}



		/*  END CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_exec_unit.src'  */


# line 158 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MxM/MxM-LLCOMP/mxm_llcomp.c" 

# line 1 "LLC code (/src/parser/llc_src/forall/forall_exit.src)" 
		/*  START CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_exit.src'  */

	if ((llc_case == LLC_GROUPS) || (llc_case == LLC_BLOCK)) {
	  free(llc_F);
	  llc_F = NULL;

		if (llc_nc_result_list.num_var > 0) {
		  llc_nc_result_destroy_var_list ();
		}
	}



		/*  END CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_exit.src'  */


# line 158 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MxM/MxM-LLCOMP/mxm_llcomp.c" 

# line 158 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/MxM/MxM-LLCOMP/mxm_llcomp.c" 

  gettimeofday (&end_time, 0);
  time = end_time.tv_sec - start_time.tv_sec;
  time = time + (end_time.tv_usec - start_time.tv_usec) / 1e6;
  MPI_Comm_size (MPI_COMM_WORLD, &MPI_NUMPROCESSORS);
  MPI_Comm_rank (MPI_COMM_WORLD, &MPI_NAME);
  printf ("%d:%f\n", MPI_NAME, time);
  free (a);
  free (b);
  free (c);
  return;
}





/*
 * vim:ts=2:sw=2:
 */

