
#include "llc.h"


# line 1 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/PI/PI-ANTO/pi_anto.c" 
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define DEFAULT_N 1000000000

# line 1 "LLC code (MAIN)" 

	/* LLC Autogenerated main */

int main (int argc, char **argv) {
	int llc_return_code = 0;

	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, (int*)&LLC_GLOBAL_NAME);
	MPI_Comm_size(MPI_COMM_WORLD, (int*)&LLC_GLOBAL_NUMPROCESSORS);
	LLC_NAME = LLC_GLOBAL_NAME;
	LLC_NUMPROCESSORS = LLC_GLOBAL_NUMPROCESSORS;
	llc_GlobalGroup = MPI_COMM_WORLD;
	llc_CurrentGroup = &llc_GlobalGroup;

	llc_return_code = llc_main (argc, argv);

	MPI_Finalize();
	return llc_return_code;
}




# line 9 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/PI/PI-ANTO/pi_anto.c" 
int llc_main (int argc, char **argv) {
  double local, pi_llc = 0.0, w;
  struct timeval start_time, end_time;
  double exe_time_llc;
  long i, N;
  int MPI_NAME, MPI_NUMPROCESSORS;
  
  N = (argc > 1) ? atol (argv[1]) : DEFAULT_N;
  w = 1.0 / N;
  gettimeofday (&start_time, 0);
   {
    			/*  START CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/master_single/master_single_exec.src'  */

		{
			int llc_numprocessors_save = LLC_NUMPROCESSORS;
			LLC_NUMPROCESSORS = 1;

			
      pi_llc = 0.0;
    

			LLC_NUMPROCESSORS = llc_numprocessors_save;
		}




			/*  END CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/master_single/master_single_exec.src'  */


# line 28 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/PI/PI-ANTO/pi_anto.c" 

    
# line 1 "LLC code (/src/parser/llc_src/forall/forall_init_unit.src)" 
			/*  START CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_init_unit.src'  */

		{	
		  /* i => Variable del bucle
		   * 0 => Valor inicial de la variable del bucle
		   * ((N) - 1) => Valor final de la variable del bucle
		   * 1 => Peso(s)
			 * LLC_NO_WEIGHTS => Flags de asignacin equitativa por pesos (LLC_WEIGHTS/LLC_NO_WEIGHTS)
			 */
		  if(LLC_NUMPROCESSORS == 1) {
		    llc_case = LLC_SEQUENTIAL;
		  }
		  else {
				if ((llc_nT = ((((N) - 1)) - (0) + 1)) >= LLC_NUMPROCESSORS) {
		  	 	register int llc_i, llc_j, llc_k;
					int llc_rnT, llc_w, llc_mW;

		  		llc_case = LLC_BLOCK;

					if ((LLC_NO_WEIGHTS) == LLC_WEIGHTS) {

								/* begin: LLC_WEIGHTS */
			    /* Obtain medium weight (only weight > 0) */
		  	    for(llc_mW = 0, i = 0; i <= ((N) - 1); i++) {
					  	if ((1) > 0) {
								llc_mW += (1);
							}
						}
						llc_mW /= LLC_NUMPROCESSORS;

			   		LLC_CHECK_MALLOC (llc_F, (LLC_NUMPROCESSORS + 1), int);
						llc_F[0] = 0;
						llc_rnT = llc_nT - LLC_NUMPROCESSORS;
			
						/* Weighted task assignement */
						i = 0;
		  	 		for(llc_i = 0; llc_i < LLC_NUMPROCESSORS; llc_i++) {
							llc_F[llc_i + 1] = llc_F[llc_i] + 1;
							llc_w = 1;
							i++;
							while ((llc_rnT > 0) && (llc_w < (llc_mW + LLC_WEIGHT_TOL))) {
								llc_F[llc_i + 1]++;
								llc_w += 1;
								i++;
								llc_rnT--;
							}
						}

						llc_i = 0;			/* Unassigned tasks: Cyclic assignment */
						while (llc_rnT > 0) {
							llc_F[(llc_i % LLC_NUMPROCESSORS) + 1]++;
							llc_rnT--;
							llc_i++;
						}
			 		}  			/* end: LLC_WEIHGTS */
					else {
									/* begin: LLC_NO_WEIGHTS */
						register int llc_i;
						/* Medium number of tasks */
						int llc_meanT = llc_nT / LLC_NUMPROCESSORS;
						/* Number of unassigned tasks */
						int llc_rnT = llc_nT % LLC_NUMPROCESSORS;
			   		
						LLC_CHECK_MALLOC (llc_F, (LLC_NUMPROCESSORS + 1), int);
						
						llc_F[0] = 0;
						for (llc_i = 1; llc_i < (LLC_NUMPROCESSORS + 1); llc_i++) { 
							llc_F[llc_i] = llc_F[llc_i-1] + llc_meanT + (((llc_i - 1) < llc_rnT) ? 1 : 0);
						}
					} 			/* end: LLC_NO_WEIGHTS */
					
				} /* LLC_BLOCK */
		  	else if(llc_nT > 0) {
					llc_case = LLC_GROUPS;
					
					if ((LLC_NO_WEIGHTS) == LLC_WEIGHTS) {
		  	 		register int llc_i, llc_j, llc_k;
		 	 			int *llc_ptr;
						int *llc_W, llc_nW;
		  			int *llc_P, llc_nP;
		  			int *llc_G;
		 
								/* begin: LLC_WEIGHTS */


		    	/* ------------------------------------------------------------
		      	 Weights processing: Threads with non-possitive weight are
			       discarded
		  	     ------------------------------------------------------------ */

						LLC_CHECK_MALLOC (llc_ptr, 3 * llc_nT, int);
						llc_W = llc_ptr;
						llc_P = llc_ptr + llc_nT;
						llc_G = llc_ptr + (2 * llc_nT);

				  	llc_k = llc_nP = LLC_NUMPROCESSORS - llc_nT + 1;
		    		for(llc_nW = 0, llc_i = 0, i = (0); i <= (((N) - 1)); i++, llc_i++) {
			      	if((llc_W[llc_i] = (1)) > 0) {
		  	      	llc_nW += llc_W[llc_i];
		    	    	if(llc_W[llc_i] < llc_k) llc_k = llc_W[llc_i];
		      		}
			      	else
		  	      	llc_W[llc_i] = 0;
		    		}

			    	/* Weights normalization */
			
		  	  	if(llc_k < llc_nP)
		    	  	for(llc_i = 0; llc_i < llc_nT; llc_i++) {
		      		 	llc_W[llc_i] *= llc_nP;
			        	llc_W[llc_i] /= llc_k;
		  	    	}

			    	/* ------------------------------------------------------------
		  	     	Processors assigment policy: BLOCK
		    	   	At least one processor by thread
		      	 	------------------------------------------------------------ */

			   		for(llc_i = 0; llc_i < llc_nT; llc_i++) {
		  	    	llc_P[llc_i] = 1;

			      	llc_j = llc_i;
		  	    	while((llc_j > 0) && (llc_W[llc_i] > llc_W[llc_G[llc_j - 1]])) {
		    	    	llc_G[llc_j] = llc_G[llc_j - 1];
		      	  	llc_j--;
			      	}
		  	    	llc_G[llc_j] = llc_i;
		    		}

			    	llc_nP = llc_nT;
		  	  	while(llc_nP++ < LLC_NUMPROCESSORS) {
		    	  	llc_W[llc_G[0]] = (llc_W[llc_G[0]] * llc_P[llc_G[0]]) /
		      	                (llc_P[llc_G[0]] + 1);
		      		llc_P[llc_G[0]]++;
			      	llc_k = llc_G[0];
		  	    	llc_j = 1;
		    	  	while((llc_j < llc_nT) && (llc_W[llc_G[llc_j]] > llc_W[llc_G[llc_j-1]])) {
		      	  	llc_G[llc_j-1] = llc_G[llc_j];
			        	llc_j++;
		  	    	}
		    	  	llc_G[llc_j-1] = llc_k;
			    	}

		  	  	/* ------------------------------------------------------------
		    	  	 Groups creation
			    	   ------------------------------------------------------------ */

						LLC_CHECK_MALLOC (llc_F, (llc_nT + 1), int);
		  	  	
						llc_F[0] = 0;
		    		for(llc_i = 1; llc_i <= llc_nT; llc_i++)
			      	llc_F[llc_i] = llc_F[llc_i-1] + llc_P[llc_i-1];
		  	                                                    		

		  	  	/* ------------------------------------------------------------
								Auxiliar variables deallocation
			    	   ------------------------------------------------------------ */

			    	free(llc_ptr);
			 		}  			/* end: LLC_WEIHGTS */
					else {
									/* begin: LLC_NO_WEIGHTS */

						register int llc_i;
						/* Medium number of processors */
						int llc_meanP = LLC_NUMPROCESSORS / llc_nT;
						/* Number of unassigned processors */
						int llc_rnP = LLC_NUMPROCESSORS % llc_nT;
			   		
						LLC_CHECK_MALLOC (llc_F, (llc_nT + 1), int);
						
						llc_F[0] = 0;
						for (llc_i = 1; llc_i < (llc_nT + 1); llc_i++) { 	
							llc_F[llc_i] = llc_F[llc_i-1] + llc_meanP + (((llc_i - 1) < llc_rnP) ? 1 : 0);
			
						}
			
					} 			/* end: LLC_NO_WEIGHTS */

		  	  /* Get the group name */
		  	  llc_grp = 0;
		 	  	while(LLC_NAME >= llc_F[llc_grp+1]) llc_grp++;
					
				} /* LLC_GROUPS */
		  	else llc_case = LLC_ERROR_CASE;
			}
		}




			/*  END CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_init_unit.src'  */


# line 36 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/PI/PI-ANTO/pi_anto.c" 

# line 1 "LLC code (/src/parser/llc_src/forall/forall_exec_unit.src)" 
			/*  START CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_exec_unit.src'  */

		{
			/* i => Variable del bucle
			 * 0 => Valor inicial de la variable del bucle
			 * ((N) - 1) => Valor final de la variable del bucle
			 * dolar3 => Bloque del bucle
			 */
			
		  int llc_case_save = llc_case;

		  switch(llc_case) {
		    case LLC_SEQUENTIAL:
		      for(i = (0); i <= (((N) - 1)); (i)++)
		         {
      local = (i + 0.5) * w;
      pi_llc = pi_llc + 4.0 / (1.0 + local * local);
    };
		    break;
		    case LLC_BLOCK:
					{
					  int llc_nP;
						register int llc_i;
					  int llc_nT_save;
					  int llc_grp_save;
						llc_var_reg_data llc_nc_result_list_save;

		 	     	llc_nP = LLC_NUMPROCESSORS;
						llc_grp_save = LLC_NAME;
			      LLC_NUMPROCESSORS = 1;
		  	    LLC_NAME = 0;
		/*				llc_nc_result_list_save_copy (llc_nc_result_list_save); */

						i = (0) + llc_F[llc_grp_save];
						for(llc_i = 0; llc_i < LLC_PROCSGRP(llc_grp_save); llc_i++, i++) {
							 {
      local = (i + 0.5) * w;
      pi_llc = pi_llc + 4.0 / (1.0 + local * local);
    };
						}
						
		/*	      if (llc_nc_result_list.num_var > 0) {
		        	llc_nc_result_destroy_var_list();
						}
		        llc_nc_result_list = llc_nc_result_list_save; */
		  	   	LLC_NAME = llc_grp_save;
		    	 	LLC_NUMPROCESSORS = llc_nP;
					}
			    break;

		    case LLC_GROUPS:
					{	
						MPI_Comm *llc_AuxGroup, llc_SubGroup;
					  int llc_nT_save;
					  int llc_grp_save;
					  int *llc_F_save;
						llc_var_reg_data llc_nc_result_list_save;


			      LLC_NAME -= llc_F[llc_grp];
		  	    LLC_NUMPROCESSORS = llc_F[llc_grp+1] - llc_F[llc_grp];
			      MPI_Comm_split(*llc_CurrentGroup, llc_grp, LLC_NAME, &llc_SubGroup);
		  	    llc_AuxGroup = llc_CurrentGroup;
		    	  llc_CurrentGroup = &llc_SubGroup;
		      	llc_nT_save = llc_nT;
			      llc_grp_save = llc_grp;
		  	    llc_F_save = llc_F;
		/*				llc_nc_result_list_save_copy (llc_nc_result_list_save); */
		        

		    	  i = (0) + llc_grp;
						 {
      local = (i + 0.5) * w;
      pi_llc = pi_llc + 4.0 / (1.0 + local * local);
    };

		/*        if (llc_nc_result_list.num_var > 0) {
		        	llc_nc_result_destroy_var_list();
						}
		        llc_nc_result_list = llc_nc_result_list_save; */
			      llc_F = llc_F_save;
		  	    llc_grp = llc_grp_save;
		    	  llc_nT = llc_nT_save;
			      LLC_NUMPROCESSORS = llc_F[llc_nT];
		  	    LLC_NAME += llc_F[llc_grp];
		    	  llc_CurrentGroup = llc_AuxGroup;
		      	MPI_Comm_free(&llc_SubGroup);
					}
			    break;
		  	}
		  llc_case = llc_case_save;
		}



			/*  END CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_exec_unit.src'  */


# line 36 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/PI/PI-ANTO/pi_anto.c" 

# line 1 "LLC code (/src/parser/llc_src/forall/forall_comm_red.src)" 
			/*  START CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_comm_red.src'  */

		{
			if ((llc_case == LLC_BLOCK) || (llc_case == LLC_GROUPS)) {
				register int llc_i, llc_k;
				char *llc_buf = NULL, *llc_buf_ptr = NULL, *llc_buf_tmp = NULL;
				int llc_buf_size, llc_size_tmp;
		  	MPI_Status llc_status;
					
				llc_buf_size = 0;

				llc_buf_size += sizeof (double);

				if (llc_buf_size > 0) {

		  	 	LLC_CHECK_MALLOC (llc_buf, llc_buf_size, char);
		  	
					if (llc_case == LLC_BLOCK) {
			
						if (LLC_NAME == 0) {
												 
		  				for (llc_i = 1; llc_i < LLC_NUMPROCESSORS; llc_i++) {
										
								MPI_Recv (llc_buf, llc_buf_size, MPI_BYTE, llc_i, LLC_TAG_REDUCE_DATA, 
																																	*llc_CurrentGroup, &llc_status);
						
								llc_buf_ptr = llc_buf;

								pi_llc += (*(double *) llc_buf_ptr);
								llc_buf_ptr +=  sizeof(double);
							}
						


							llc_buf_ptr = llc_buf;

							memcpy (llc_buf_ptr, &pi_llc, sizeof(double));
							llc_buf_ptr += sizeof(double);

							MPI_Bcast (llc_buf, llc_buf_size, MPI_BYTE, 0, *llc_CurrentGroup);

						}
						else {

							llc_buf_ptr = llc_buf;

							memcpy (llc_buf_ptr, &pi_llc, sizeof(double));
							llc_buf_ptr += sizeof(double);
						
							MPI_Send (llc_buf, llc_buf_size, MPI_BYTE, 0, LLC_TAG_REDUCE_DATA, *llc_CurrentGroup);


							MPI_Bcast (llc_buf, llc_buf_size, MPI_BYTE, 0, *llc_CurrentGroup);
					
							llc_buf_ptr = llc_buf;

							memcpy (&pi_llc, llc_buf_ptr, sizeof(double));
							llc_buf_ptr += sizeof(double);
						}
					}
					else {
						if (llc_case == LLC_GROUPS) {
			
							if (LLC_NAME == 0) {

								for (llc_i = 1; llc_i < llc_nT; llc_i++) {
									
				  				MPI_Recv (llc_buf, llc_buf_size, MPI_BYTE, llc_F[llc_i], LLC_TAG_REDUCE_DATA, 
																																	*llc_CurrentGroup, &llc_status);
								
									llc_buf_ptr = llc_buf;

									pi_llc += (*(double *) llc_buf_ptr);
									llc_buf_ptr +=  sizeof(double);
								}

								llc_buf_ptr = llc_buf;

								memcpy (llc_buf_ptr, &pi_llc, sizeof(double));
								llc_buf_ptr += sizeof(double);
						

								MPI_Bcast (llc_buf, llc_buf_size, MPI_BYTE, 0, *llc_CurrentGroup);	
							}
							else {
								for (llc_i = 1; llc_i < llc_nT; llc_i++) {
							
									if (LLC_NAME == llc_F[llc_i]) {
								
										llc_buf_ptr = llc_buf;

										memcpy (llc_buf_ptr, &pi_llc, sizeof(double));
										llc_buf_ptr += sizeof(double);

										MPI_Send (llc_buf, llc_buf_size, MPI_BYTE, 0, LLC_TAG_REDUCE_DATA, *llc_CurrentGroup);
			
										break;
			
									}
								}
							
								MPI_Bcast (llc_buf, llc_buf_size, MPI_BYTE, 0, *llc_CurrentGroup);
						
							llc_buf_ptr = llc_buf;

							memcpy (&pi_llc, llc_buf_ptr, sizeof(double));
							llc_buf_ptr += sizeof(double);

								
							}
					
					
						}
					}
					free (llc_buf);
					free (llc_buf_tmp);
				}
			}
		}




			/*  END CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_comm_red.src'  */


# line 36 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/PI/PI-ANTO/pi_anto.c" 

# line 1 "LLC code (/src/parser/llc_src/forall/forall_exit.src)" 
			/*  START CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_exit.src'  */

		if ((llc_case == LLC_GROUPS) || (llc_case == LLC_BLOCK)) {
		  free(llc_F);
		  llc_F = NULL;

			if (llc_nc_result_list.num_var > 0) {
			  llc_nc_result_destroy_var_list ();
			}
		}



			/*  END CODE FROM '/home/ray/Proyecto/yaCF-MPI-doc/src/llCoMP_Antonio/llCoMP/src/parser/llc_src/forall/forall_exit.src'  */


# line 36 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/PI/PI-ANTO/pi_anto.c" 

# line 36 "/home/ray/Proyecto/yaCF-MPI-src/examples/MPI_examples/PI/PI-ANTO/pi_anto.c" 

  }
  gettimeofday (&end_time, 0);
  exe_time_llc = end_time.tv_sec - start_time.tv_sec;
  exe_time_llc = exe_time_llc + (end_time.tv_usec - start_time.tv_usec) / 1e6;
  pi_llc *= w;
  MPI_Comm_size (MPI_COMM_WORLD, &MPI_NUMPROCESSORS);
  MPI_Comm_rank (MPI_COMM_WORLD, &MPI_NAME);
  printf ("%d:%f:%f\n", MPI_NAME, exe_time_llc, pi_llc);
  return 0;
}





/*
 * vim:ts=2:sw=2:
 */

