/* ***********************************************************************
  FILE:              fibon.c
  VERSION:           1.0
  DATE:              Feb 2009
  AUTHOR:            F. de Sande
  COMMENTS TO:       fsande@ull.es
  DESCRIPTION:       
  COMMENTS:	     
  REFERENCES:        http://terboven.spaces.live.com/blog/cns!EA3D3C756483FECB!316.entry
  INPUT:             
  OUTPUT:            
  FILE FORMATS:      -
  RESTRICTIONS:      -
  REVISION HISTORY:
**************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <omp.h>

/* First fibonnaci number to compute */
#ifndef N
#define N 40
#endif

/* Number of fibonacci numbers to compute */
#ifndef NFIB 
#define NFIB 1  
#endif

/* Computes (recursively) fibonnaci number n */
unsigned fib_par(unsigned n) {
   if (n < 2) return (n);
   int x, y;
   #pragma omp task shared(x)
      x = fib_par(n - 1);
   #pragma omp task shared(y)
      y = fib_par(n - 2);
   #pragma omp taskwait
    return (x + y);
}

int main(int argc, char *argv[]) {
  double start, end;
  int i;
  unsigned result;
    
  printf("Starting at fib(%d)\n", N);
  start = omp_get_wtime();
  #pragma omp parallel
  {
    printf("Executing with %d threads\n", omp_get_num_threads());

    #pragma omp single
      result = fib_par(N);

    #pragma omp single
      printf("fib(%i): %d\n", N, result);
  }
  end = omp_get_wtime();

  printf("Compute Time: %f seconds\n", end - start);
  return 0;
}

/*
 * vim:ts=2:sw=2
 */
