
/* Real type. */
typedef double real;

/* 2d vector struct. */
typedef struct {
        real x, y;
} le_vec2;

/* 
 * Symmetrical tensor 2d.
 * sxx sxy
 * sxy sxx
 */
typedef struct {
        real xx, xy, yy;
} le_smatrix2;

/*
 * Elastic node structure.
 * Store velocity and stress tensor (http://en.wikipedia.org/wiki/Stress_%28mechanics%29).
 */
typedef struct {
  le_vec2 v;
  le_smatrix2 s;
} le_node;

/*
 * Riemann invariant structure (http://en.wikipedia.org/wiki/Riemann_invariant).
 */
typedef struct {
  real w1, w2, w3, w4, w5;
} le_w;

int main() {

  le_node inGrid;
  le_node array[100];

  int i,j;
  
  #pragma acc kernels present(inGrid,array[0:100])
  for (j = 0; j < 10; j++)
  {
      real nv = inGrid.v.x;
      nv = array[0].v.x;
      le_w w_2;
  }  
  
  #pragma acc parallel loop gang, present(inGrid,array[0:10])
  for (j = 0; j < 10; j++) {
    #pragma acc loop vector
    for (i = 0; i < 10; i++){
      /* Riemann invariants for 5-point sctencil difference scheme.
       */
      le_w w_2;
      
    }
    
  }
  
}
