##################################################
#                Frangollo Makefile
# 
#  
##################################################
# Edit the values below to match those of your platform
# They are used when compiling your code in the destination platform

###### General building options
# C compiler , typically gcc although others should work
CC=gcc
# C++ compiler, the same used to build Frangollo
CXX=g++
# C flags required to build a binary for your platform. 
# Include here any optimization flag you want to add.
CCFLAGS= -std=c99 -O3

# Path to Frangollo installation
FRANGOLLO_DIR=$(FRANGOLLODIR)

##### Platform lib used 

ifndef $(NVCCARCH)
NVCCARCH=$(DEFAULTARCH)
endif

# ----> MacOS platform
# CURRENT_LIB=-framework OpenCL
# ----> Typical CUDA 
# CUDA compiler name (if avail)
NVCC=$(CUDADIR)/bin/nvcc
NVCCFLAGS=  -Xcompiler -fopenmp -arch=$(NVCCARCH)  -lrt
CCFLAGS+= -lrt -fopenmp -lcuda -D_POSIX_C_SOURCE=199309L -lrt -g
CURRENT_LIB=-lcuda -lOpenCL -lrt -L$(CUDADIR)/lib64/ -lcuda

# NVCC=
# CCFLAGS+=-O3
# CURRENT_LIB= # Linking options for your platform, e.g -lcuda


## CUDA only defaults
default: main  kernel_cuda support_cuda kernel_host
## or to compile executable simply 
# default: cuda_exe
## OpenCL only defaults
# default: main support_cl kernel_host
## or to compile executable simply 
# default: opencl_exe
